/*-- vanaf 10.3 zijn de volgende velden vervangen:
   ca-service.ind_delivery --> ca-service.input_place_delivery 
   ca-service.ind_loading  --> ca-service.input_place_receipt
   
   Nu alleen de data nog overnemen.
   En per 11.4 kunnen dan velden ind_delivery & ind_loading uit de database 
   verdwijnen. dan zijn alle klanten over en heeft iedereen dit script doorlopen
   en worden deze velden redundant.
   --*/

/*--indien al een keer uitgevoerd, dan overslaan --*/
IF CAN-FIND(FIRST sp-control WHERE 
                  sp-control.controlkode EQ THIS-PROCEDURE:FILE-NAME )
THEN RETURN.

/*--ivm met performance triggers disablen --*/
DISABLE TRIGGERS FOR LOAD OF ca-service.
 
DEF VAR cProgram                      AS CHAR NO-UNDO.
DEF VAR cAction                       AS CHAR NO-UNDO.
DEF VAR cTable                        AS CHAR NO-UNDO.
DEF VAR iTotal                        AS INT  NO-UNDO.
DEF VAR iDone                         AS INT  NO-UNDO.
DEF VAR iModulo                       AS INT  NO-UNDO.

ASSIGN cProgram =  THIS-PROCEDURE:FILE-NAME
       cAction  = ''
       iModulo  =  100.  /* om de 100 records info tonen */

FORM 'Program  :' AT 1 cProgram   NO-LABEL  FORMAT 'x(50)'    AT 12  SKIP
     'Action   :' AT 1 cAction    NO-LABEL  FORMAT 'x(50)'    AT 12  SKIP
     'Table    :' AT 1 cTable     NO-LABEL  FORMAT 'x(50)'    AT 12  SKIP
     'Total    :' AT 1 iTotal     NO-LABEL  FORMAT '9999999'  AT 12  SKIP
     'Done     :' AT 1 iDone      NO-LABEL  FORMAT '9999999'  AT 12  SKIP   
     WITH FRAME a.

&GLOBAL-DEFINE mydisplay cProgram cAction cTable iTotal iDone  WITH FRAME a

ASSIGN cTable  = ''
       cAction = 'Counting..' .
DISPLAY {&mydisplay}.
/*****************************************************************************************************
   EVEN TELLEN, niet echt noodzakelijk ..
*****************************************************************************************************/
SELECT COUNT(*) INTO iTotal FROM ca-service.
DISPLAY {&mydisplay}.

/*****************************************************************************************************
    SHIPMENT BIJWERKEN
*****************************************************************************************************/
ASSIGN cTable  = 'ca-service'
       cAction = 'updating loading & delivery settings' .
DISPLAY {&mydisplay}.

ASSIGN iDone = 0.
FOR EACH ca-service 
         FIELDS(ind_delivery ind_loading input_place_delivery input_place_receipt) 
         EXCLUSIVE-LOCK TRANSACTION:
   ASSIGN iDone = iDone + 1 
          ca-service.input_place_delivery = (IF ca-service.input_place_delivery EQ 'N'
                                             THEN 'N' /*not applicable*/
                                             ELSE IF ca-service.ind_delivery
                                                  THEN 'M'  /*mandatory*/
                                                  ELSE 'O') /*optional*/
          ca-service.input_place_receipt  = (IF ca-service.input_place_receipt  EQ 'N'
                                             THEN 'N'
                                             ELSE IF ca-service.ind_loading  
                                                  THEN 'M'
                                                  ELSE 'O').
   
   IF iDone MODULO iModulo EQ 0 
   THEN DISPLAY {&mydisplay}.       
END. /*each ca-vessel*/

/*****************************************************************************************************
     registreren voor toekomstige runs dat deze script al is uitgevoerd en kan worden overgeslagen
*****************************************************************************************************/
ASSIGN cTable  = ''
       cAction = 'Done...' .
DISPLAY {&mydisplay}.

DO TRANSACTION:
   CREATE sp-control.
   ASSIGN sp-control.controlkode = THIS-PROCEDURE:FILE-NAME
          sp-control.lijst       = 'uitgevoerd op ' + STRING(TODAY,'99-99-9999') + ' ' + STRING(TIME,'HH:MM:SS')
          sp-control.uitleg      = cAction .
END. /*transaction*/
                    

   
