&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v9r12
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS Procedure
/*------------------------------------------------------------------------
    File        : ca-sync-transportplanning.p
    Purpose     : Sync shipments to transportdossiers

    Syntax      :

    Description :

    Author(s)   : peterba
    Created     : Nov 5 2010
    Notes       :
  ----------------------------------------------------------------------*/
/*          This .W file was created with the Progress AppBuilder.      */
/*----------------------------------------------------------------------*/

/* ***************************  Definitions  ************************** */

DEFINE INPUT  PARAMETER param-shipment_seqnr    AS INTEGER   NO-UNDO.
DEFINE INPUT  PARAMETER param-item_seqnr        AS INTEGER   NO-UNDO.
DEFINE INPUT  PARAMETER param-quotation_seqnr   AS INTEGER   NO-UNDO.
DEFINE INPUT  PARAMETER param-tp_file_seqnr     AS INTEGER   NO-UNDO.
DEFINE INPUT  PARAMETER param-qualifier         AS CHARACTER NO-UNDO.
DEFINE INPUT  PARAMETER param-vesselnr          AS INTEGER   NO-UNDO.
DEFINE INPUT  PARAMETER param-containerprefix   AS CHARACTER NO-UNDO.
DEFINE INPUT  PARAMETER param-containernr       AS CHARACTER NO-UNDO.
DEFINE INPUT  PARAMETER param-action            AS CHARACTER NO-UNDO.
DEFINE OUTPUT PARAMETER param-result            AS LOGICAL   NO-UNDO.

{system/super/sp-file.i}
{System/include/sp-global-def.i}
{system/include/sp-spMailWithBlat-def.i}


DEF TEMP-TABLE ttContainer NO-UNDO
   FIELD nr AS INTEGER
   FIELD containernr      AS CHAR
   FIELD containerprefix  AS CHAR
   FIELD containertype    AS CHAR
   FIELD sealno           AS CHAR
   FIELD release-pincode  AS CHAR
   FIELD ca_container_id  AS CHAR
   FIELD no_packages      AS INT
   FIELD weight           AS INT
   FIELD measurement      AS INT
   .

DEF VAR lMulti                       AS LOGICAL   NO-UNDO.
DEF VAR iConnect2shipment_item_seqnr AS INTEGER   NO-UNDO.
DEF VAR iItem-no_of_containers       AS INTEGER   NO-UNDO.
DEF VAR gcTP_file_type               AS CHARACTER NO-UNDO.
DEF VAR glSchedulerActive            AS LOGICAL   NO-UNDO.
DEF VAR iPrgIdx                      AS INTEGER   NO-UNDO.


DEF TEMP-TABLE ttTPfile
  FIELD thisrowid AS ROWID
  INDEX main AS PRIMARY thisrowid.

DEF VAR glUseLogging AS LOGICAL NO-UNDO INITIAL NO.

DEF STREAM logfile.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE Procedure
&Scoped-define DB-AWARE no



/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME


/* ************************  Function Prototypes ********************** */

&IF DEFINED(EXCLUDE-ShowMessage) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD ShowMessage Procedure
FUNCTION ShowMessage RETURNS LOGICAL
  ( pcProcName AS CHAR,
    pcKeys AS CHAR,
    pcMessage AS CHAR,
    pcMessageType AS CHARACTER,
   plBlatOnly AS LOGICAL)  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-spCloseLogfile) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD spCloseLogfile Procedure
FUNCTION spCloseLogfile RETURNS CHARACTER
  ( )  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-spGetEntry) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD spGetEntry Procedure
FUNCTION spGetEntry RETURNS CHARACTER
   ( pcLabel      AS CHAR,
    pcValueList  AS CHAR,
    pcSep1       AS CHAR,
    pcSep2       AS CHAR )  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-spLogThis) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD spLogThis Procedure
FUNCTION spLogThis RETURNS LOGICAL
  ( INPUT pText         AS CHAR,
    INPUT pTimeStamp    AS LOGICAL,
    INPUT pSkipBefore   AS LOGICAL,
    INPUT pSkipAfter    AS LOGICAL )  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-spOpenLogfile) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD spOpenLogfile Procedure
FUNCTION spOpenLogfile RETURNS CHARACTER
  ( /* parameter-definitions */ )  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-TransportfileHasBeenUsed) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD TransportfileHasBeenUsed Procedure
FUNCTION TransportfileHasBeenUsed RETURNS LOGICAL
  ( pRowid AS ROWID )  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-TransportFileMarkAsUsed) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD TransportFileMarkAsUsed Procedure
FUNCTION TransportFileMarkAsUsed RETURNS LOGICAL
  ( prowid AS ROWID )  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Procedure
   Allow:
   Frames: 0
   Add Fields to: Neither
   Other Settings: CODE-ONLY
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
/* DESIGN Window definition (used by the UIB)
  CREATE WINDOW Procedure ASSIGN
         HEIGHT             = 23.57
         WIDTH              = 65.8.
/* END WINDOW DEFINITION */
                                                                        */
&ANALYZE-RESUME




&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK Procedure


/* ***************************  Main Block  *************************** */

/* VIEW FRAME w8ff.                 */
/*                                  */
/* DISPLAY cWaarom WITH FRAME w8ff. */
/*                                  */
/*                                  */

DEF BUFFER b-shipment FOR ca-u_shipment.


param-result = YES.

IF LOOKUP("AA.TP",sp-licenses) = 0
THEN RETURN.

{system/include/sp-spMailWithBlat-init.i}

glSchedulerActive = NO.
DO iPrgIdx = 1 TO 99 WHILE PROGRAM-NAME(iPrgIdx) <> ?:
  IF INDEX(PROGRAM-NAME(iPrgIdx),"w-aa-scheduler") > 0
  THEN DO:
    glSchedulerActive = YES.
    LEAVE.
  END.
END.

/* SESSION:SET-WAIT-STATE("GENERAL"). LLe Effe niet i.v.m. insensitive session */

IF param-shipment_seqnr <> 0
THEN DO:

  FIND FIRST b-shipment WHERE
             b-shipment.companycode = sp-companycode AND
             b-shipment.shipment_seqnr = param-shipment_seqnr NO-LOCK NO-ERROR.
  IF NOT AVAIL b-shipment THEN RETURN.

  FIND FIRST ca-service WHERE
             ca-service.companycode = sp-companycode AND
             ca-service.servicecode = b-shipment.servicecode NO-LOCK NO-ERROR.
  IF NOT AVAILABLE ca-service THEN RETURN.

  IF NOT ca-service.ind_transport_col AND NOT ca-service.ind_transport_del AND NOT ca-service.ind_transport_shunt
  THEN
    RETURN. /* nothing to do */

  IF b-shipment.dt_ets <= DATE(12,31,2013)
  THEN DO:
    IF sp-userid <> "baaijens"
    THEN
      RETURN.  /* Do not sync old shipments */

  END.

  /* --- */

  gcTP_file_type = "".

  IF ca-service.ind_transport_del AND NOT ca-service.ind_transport_col
  THEN gcTP_file_type = "DEL".
  ELSE IF NOT ca-service.ind_transport_del AND ca-service.ind_transport_col
  THEN gcTP_file_type = "COLL".
  ELSE IF ca-service.ind_transport_del AND ca-service.ind_transport_col
  THEN gcTP_file_type = "COLL+DEL".
  ELSE IF ca-service.ind_transport_shunt
  THEN gcTP_file_type = "SHUNTING".

END.

/* --- */

spLogThis (FILL("-",60)                , NO /* time */, YES /* skip before */, YES /* skip after */ ).
spLogThis ("START SYNC " + param-action, YES /* time */, YES /* skip before */, YES /* skip after */ ).

DO iPrgIdx = 1 TO 6 WHILE PROGRAM-NAME(iPrgIdx) <> ?:
  spLogThis ("call stack(" + string(iPrgIdx) + "): " + PROGRAM-NAME(iPrgIdx), NO,NO,YES).
  IF INDEX(PROGRAM-NAME(iPrgIdx),"dbtrigger") > 0
  THEN
    LEAVE.
END.


CASE param-action:

  WHEN "SYNC-U-SHIPMENT"                        THEN RUN caSync-u-shipment                  (param-shipment_seqnr, OUTPUT param-result).
  WHEN "SYNC-U-SHIPMENT-ITEM"                   THEN RUN caSync-u-shipment-item             (param-shipment_seqnr, param-item_seqnr,
                                                                                             OUTPUT param-result).
  WHEN "SYNC-U-SHIPMENT-ADDRESS"                THEN RUN caSync-u-shipment-address          (param-shipment_seqnr,                    param-qualifier, NO, "").
  WHEN "SYNC-U-SHIPMENT-ITEM-ADDRESS"           THEN RUN caSync-u-shipment-item-address     (param-shipment_seqnr, param-item_seqnr,  param-qualifier, 0, NO,
                                                                                             OUTPUT param-result).
  WHEN "SYNC-U-SHIPMENT-ITEM-ADDRESS-QUALIFIER" THEN RUN caSync-u-shipment-item-address-q   (param-shipment_seqnr, param-item_seqnr,  param-qualifier).
  WHEN "SYNC-U-VOYAGE"                          THEN RUN caSync-u-voyage                    (param-vesselnr,?).
  WHEN "SYNC-U-VOYAGE-CONTAINER"                THEN RUN caSync-u-voyage-container          (param-vesselnr, param-containerprefix, param-containernr).
  WHEN "SYNC-U-VOYAGE-SHIPMENT"                 THEN RUN caSync-u-voyage-shipment           (param-shipment_seqnr, param-item_seqnr, param-tp_file_seqnr, param-qualifier).
  WHEN "SYNC-U-SHIPMENT-TRANSFER"               THEN RUN caSync-u-shipment-transfer         (param-shipment_seqnr, param-qualifier).
  WHEN "SYNC-U-DELETE-ITEM-CONTAINER"           THEN RUN caSync-u-shipment-item-container-d (param-shipment_seqnr, param-item_seqnr,  param-containerprefix, param-containernr,"DELETE").
  OTHERWISE DO:
    param-result = FALSE.
    ShowMessage("ca-sync-transportplanning","mainblock","Not implemented yet; ca-sync-transportplanning: " + param-action,"ERROR",NO).
  END.

END CASE.

spLogThis ("END SYNC", YES /* time */, YES /* skip before */, YES /* skip after */ ).

HIDE FRAME w8ff.

IF NOT param-result
THEN DO:

  MESSAGE "Bad sync result CA-TP - last change is cancelled / rollback last transaction" VIEW-AS ALERT-BOX WARNING TITLE "ca-sync-transportplanning".

END.


/* SESSION:SET-WAIT-STATE(""). LLe Effe niet i.v.m. insensitive session */

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&IF DEFINED(EXCLUDE-aaSetStartAndEndpoints) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE aaSetStartAndEndpoints Procedure
PROCEDURE aaSetStartAndEndpoints :
/*------------------------------------------------------------------------------
  Purpose:
  Parameters:  <none>
  Notes:
------------------------------------------------------------------------------*/

  DEFINE INPUT PARAMETER pcCompanycode             AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER piShipment                AS INTEGER   NO-UNDO.
  DEFINE INPUT PARAMETER piItemNr                  AS INTEGER   NO-UNDO.

  spLogThis ("aaSetStartAndEndpoints", YES /* time */, YES /* skip before */, YES /* skip after */ ).

  FOR EACH aa-tp_file WHERE
           aa-tp_file.companycode    = pcCompanycode AND
           aa-tp_file.shipment_seqnr = piShipment AND
           aa-tp_file.item_seqnr     = piItemNr NO-LOCK:

    {aa/include/aa-tp_setstartendpoints.i}

  END.

  spLogThis ("aaSetStartAndEndpoints done", YES /* time */, YES /* skip before */, YES /* skip after */ ).

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-caSync-FixDelivery0Loading9) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE caSync-FixDelivery0Loading9 Procedure
PROCEDURE caSync-FixDelivery0Loading9 :
/*------------------------------------------------------------------------------
  Purpose:
  Parameters:  <none>
  Notes:
------------------------------------------------------------------------------*/

   DEFINE INPUT PARAMETER piShipment_seqnr AS INTEGER   NO-UNDO.

   DEF BUFFER b-ca-u_shipment      FOR ca-u_shipment.
   DEF BUFFER b-aa-tp_file         FOR aa-tp_file.
   DEF BUFFER b-aa-tp_file_address FOR aa-tp_file_address.

   spLogThis ("caSync-FixDelivery0Loading9", YES /* time */, YES /* skip before */, YES /* skip after */ ).

   FIND FIRST b-ca-u_shipment WHERE
              b-ca-u_shipment.companycode = sp-companycode AND
              b-ca-u_shipment.shipment_seqnr = piShipment_seqnr NO-LOCK NO-ERROR.
   IF NOT AVAIL b-ca-u_shipment THEN RETURN.

   /* --- */

   IF gcTP_file_type = "COLL+DEL"
   THEN DO:
     RUN caSync-u-shipment-address (b-ca-u_shipment.shipment_seqnr,
                                    "LOADING 9",
                                    YES, /* auto create */
                                    b-ca-u_shipment.locationcode).

     RUN caSync-u-shipment-address (b-ca-u_shipment.shipment_seqnr,
                                    "DELIVERY 0",
                                    YES, /* auto create */
                                    b-ca-u_shipment.pod_locationcode).
   END.

   IF gcTP_file_type = "DEL"
   THEN
     RUN caSync-u-shipment-address (b-ca-u_shipment.shipment_seqnr,
                                    "DELIVERY 0",
                                    YES, /* auto create */
                                    b-ca-u_shipment.pod_locationcode).
   IF gcTP_file_type = "COLL"
   THEN
    RUN caSync-u-shipment-address (b-ca-u_shipment.shipment_seqnr,
                                   "LOADING 9",
                                   YES, /* auto create */
                                   b-ca-u_shipment.locationcode).


   spLogThis ("caSync-FixDelivery0Loading9 done", YES /* time */, YES /* skip before */, YES /* skip after */ ).

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-caSync-GetContainerContent) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE caSync-GetContainerContent Procedure
PROCEDURE caSync-GetContainerContent :
/*------------------------------------------------------------------------------
  Purpose:
  Parameters:  <none>
  Notes:
------------------------------------------------------------------------------*/

   DEFINE INPUT        PARAMETER piShipment_seqnr  AS INTEGER NO-UNDO.
   DEFINE INPUT        PARAMETER piVesselNr        AS INTEGER NO-UNDO.
   DEFINE INPUT        PARAMETER pcContainerprefix AS CHAR    NO-UNDO.
   DEFINE INPUT        PARAMETER pcContainernr     AS CHAR    NO-UNDO.
   DEFINE INPUT-OUTPUT PARAMETER piNo_packages     AS INT     NO-UNDO.
   DEFINE INPUT-OUTPUT PARAMETER piCargo_weight    AS INT     NO-UNDO.
   DEFINE INPUT-OUTPUT PARAMETER pcName_of_goods   AS CHAR    NO-UNDO.
   DEFINE INPUT-OUTPUT PARAMETER pcKind_packages   AS CHAR    NO-UNDO.

   DEF BUFFER b-multi-item-container FOR ca-u_shipment_item_container.
   DEF BUFFER b-multi-item           FOR ca-u_shipment_item.

   &SCOPED-DEFINE NAME-OF-GOODS ~
       IF b-multi-item.name_of_goods <> "" AND INDEX(pcName_of_goods,b-multi-item.name_of_goods) = 0 ~
       THEN ~
         pcName_of_goods = pcName_of_goods + (IF pcName_of_goods <> "" THEN " / " ELSE "") + b-multi-item.name_of_goods.


   &SCOPED-DEFINE KIND-OF-PACKAGES ~
       IF b-multi-item.kind_packages <> "" AND INDEX(pcKind_packages,b-multi-item.kind_packages) = 0 ~
       THEN ~
         pcKind_packages = pcKind_packages + (IF pcKind_packages <> "" THEN " / " ELSE "") + b-multi-item.kind_packages.


   spLogThis ("caSync-GetContainerContent", YES /* time */, YES /* skip before */, YES /* skip after */ ).

   ASSIGN
     piNo_packages   = 0
     piCargo_weight  = 0
     pcName_of_goods = ""
     pcKind_packages = "".

   /* ----------------------------------------------------------------------------------------- */
   /* Zijn er containers aanwezig; zo ja dan hier gewicht enzo uit halen */
   /* ----------------------------------------------------------------------------------------- */
   IF CAN-FIND (FIRST b-multi-item-container WHERE
                      b-multi-item-container.companycode     = sp-companycode    AND
                      b-multi-item-container.vesselnr        = piVesselnr        AND
                      b-multi-item-container.containerprefix = pcContainerprefix AND
                      b-multi-item-container.containernr     = pcContainernr)
   THEN

     FOR EACH b-multi-item-container WHERE
              b-multi-item-container.companycode     = sp-companycode    AND
              b-multi-item-container.vesselnr        = piVesselnr        AND
              b-multi-item-container.containerprefix = pcContainerprefix AND
              b-multi-item-container.containernr     = pcContainernr     NO-LOCK,
        FIRST b-multi-item WHERE
              b-multi-item.companycode = sp-companycode AND
              b-multi-item.shipment_seqnr = b-multi-item-container.shipment_seqnr AND
              b-multi-item.item_seqnr = b-multi-item-container.item_seqnr
              NO-LOCK:

       piNo_packages   = piNo_packages   + b-multi-item-container.no_packages.
       piCargo_weight  = piCargo_weight  + b-multi-item-container.weight.
       {&NAME-OF-GOODS}
       {&KIND-OF-PACKAGES}

     END.

   ELSE
     /* ----------------------------------------------------------------------------------------- */
     /* Geen containers hier nog; gewicht enzo uit de shipment items halen */
     /* ----------------------------------------------------------------------------------------- */

     FOR EACH b-multi-item  WHERE
              b-multi-item.companycode = sp-companycode AND
              b-multi-item.shipment_seqnr = piShipment_seqnr NO-LOCK:

       piNo_packages   = piNo_packages   + b-multi-item.no_packages.
       piCargo_weight  = piCargo_weight  + b-multi-item.weight.
       {&NAME-OF-GOODS}
       {&KIND-OF-PACKAGES}
     END.


     spLogThis ("caSync-GetContainerContent done", YES /* time */, YES /* skip before */, YES /* skip after */ ).

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-caSync-GetImoReeferWaste) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE caSync-GetImoReeferWaste Procedure
PROCEDURE caSync-GetImoReeferWaste :
DEFINE INPUT  PARAMETER pmiShipmentSeqnr     AS INTEGER NO-UNDO.
  DEFINE INPUT  PARAMETER pmiItemSeqnr         AS INTEGER NO-UNDO.

  DEFINE OUTPUT PARAMETER pmlHasIMO            AS LOGICAL NO-UNDO.
  DEFINE OUTPUT PARAMETER pmlHasReefer         AS LOGICAL NO-UNDO.
  DEFINE OUTPUT PARAMETER pmlHasWaste          AS LOGICAL NO-UNDO.

  DEFINE OUTPUT PARAMETER pmcCargotype         AS CHARACTER NO-UNDO.
  DEFINE OUTPUT PARAMETER pmiReeferMin         AS INT       NO-UNDO.
  DEFINE OUTPUT PARAMETER pmiReeferMax         AS INT       NO-UNDO.
  DEFINE OUTPUT PARAMETER pmcReeferVentilation AS CHARACTER NO-UNDO.
  DEFINE OUTPUT PARAMETER pmcImoClass          AS CHARACTER NO-UNDO.
  DEFINE OUTPUT PARAMETER pmcImoUNNO           AS CHARACTER NO-UNDO.
  DEFINE OUTPUT PARAMETER pmcImoMfag           AS CHARACTER NO-UNDO.
  DEFINE OUTPUT PARAMETER pmcImoEms            AS CHARACTER NO-UNDO.
  DEFINE OUTPUT PARAMETER pmcImoFlashpoint     AS CHARACTER NO-UNDO.

  DEFINE BUFFER b-ca-u_shipment      FOR ca-u_shipment.
  DEFINE BUFFER b-ca-u_shipment_item FOR ca-u_shipment_item.
  DEFINE BUFFER b-ca-cargotype       FOR ca-cargotype.

  DEFINE VARIABLE cCargotype         AS CHARACTER NO-UNDO.


  FIND FIRST b-ca-u_shipment WHERE
             b-ca-u_shipment.companycode = sp-companycode AND
             b-ca-u_shipment.shipment_seqnr = pmiShipmentSeqnr NO-LOCK NO-ERROR.

  FOR EACH b-ca-u_shipment_item WHERE
           b-ca-u_shipment_item.companycode    = b-ca-u_shipment.companycode AND
           b-ca-u_shipment_item.shipment_seqnr = b-ca-u_shipment.shipment_seqnr NO-LOCK:


     IF (b-ca-u_shipment.ind_multi_delivery OR b-ca-u_shipment.ind_multi_receipt)
     THEN DO:
        /* nothing here, just walk loop. In case of multi all items must be read */
     END.
     ELSE DO:
       IF b-ca-u_shipment_item.item_seqnr <> pmiItemSeqnr
       THEN NEXT.
     END.

     FIND FIRST b-ca-cargotype WHERE
                b-ca-cargotype.cargotypecode = b-ca-u_shipment_item.cargotypecode NO-LOCK NO-ERROR.

     IF AVAIL b-ca-cargotype
     THEN DO:

        IF LOOKUP(b-ca-u_shipment_item.cargotypecode,"/") = 0
        THEN
          pmcCargotype = pmcCargotype + (IF pmcCargotype <> "" THEN "/" ELSE "") + b-ca-u_shipment_item.cargotypecode.

        IF b-ca-cargotype.imo
        THEN pmlHasIMO = YES.

        IF b-ca-cargotype.reefer
        THEN pmlHasReefer = YES.

        IF b-ca-cargotype.waste
        THEN pmlHasWaste = YES.

        /* is this item more dangerous then previous items */
        IF (b-ca-u_shipment_item.imo_class <> "" AND b-ca-u_shipment_item.imo_class < pmcImoClass) OR pmcImoClass = ""
        THEN DO:

          pmcImoClass      = b-ca-u_shipment_item.imo_class.
          pmcImoUNNO       = b-ca-u_shipment_item.imo_unno.
          pmcImoMfag       = b-ca-u_shipment_item.imo_mfagcode.
          pmcImoFlashpoint = b-ca-u_shipment_item.imo_flashpoint.
          pmcImoEms        = b-ca-u_shipment_item.imo_emscode.

        END.

        IF b-ca-cargotype.reefer  /* Always from 1st reefer item */
        THEN DO:
          pmiReeferMin         = b-ca-u_shipment_item.reefer_temp1.
          pmiReeferMax         = b-ca-u_shipment_item.reefer_temp2.
          pmcReeferVentilation = b-ca-u_shipment_item.ventilation.
        END.

     END. /* avail cargotype */

  END. /* walk over items */

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-caSync-IMO) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE caSync-IMO Procedure
PROCEDURE caSync-IMO :
/*------------------------------------------------------------------------------
  Purpose:
  Parameters:  <none>
  Notes:
------------------------------------------------------------------------------*/

  DEFINE INPUT  PARAMETER pShipment_seqnr           AS INTEGER NO-UNDO.
  DEFINE INPUT  PARAMETER pItem_seqnr               AS INTEGER NO-UNDO.
  DEFINE INPUT  PARAMETER pTransportfile_seqnr      AS INTEGER NO-UNDO.
  DEFINE OUTPUT PARAMETER pLicenseTypesNeeded       AS CHAR    NO-UNDO.

  FOR EACH ca-u_shipment_item_imo WHERE
           ca-u_shipment_item_imo.companycode    = sp-companycode AND
           ca-u_shipment_item_imo.shipment_seqnr = pShipment_seqnr AND
           ca-u_shipment_item_imo.item_seqnr     = pItem_seqnr NO-LOCK,
     FIRST aa-imo WHERE
           aa-imo.imo_seqnr = ca-u_shipment_item_imo.imo_seqnr NO-LOCK:

    IF aa-imo.tp_licensetype <> ""
    THEN DO:
      /* TODO: aa-tp_file_license vullen */
      IF NOT CAN-FIND (FIRST aa-tp_file_license WHERE
                             aa-tp_file_license.companycode = sp-companycode AND
                             aa-tp_file_licenses.tp_file_seqnr = pTransportfile_seqnr AND
                             aa-tp_file_licenses.tp_licensetype = aa-imo.tp_licensetype)
      THEN DO:
         CREATE aa-tp_file_license.
         ASSIGN aa-tp_file_license.companycode = sp-companycode
                aa-tp_file_licenses.tp_file_seqnr = pTransportfile_seqnr
                aa-tp_file_licenses.tp_licensetype = aa-imo.tp_licensetype.
      END.

      pLicenseTypesNeeded = pLicenseTypesNeeded +
                            (IF pLicenseTypesNeeded <> "" THEN CHR(3) ELSE "") +
                            aa-imo.tp_licensetype.
    END.

  END.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-caSync-quotation) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE caSync-quotation Procedure
PROCEDURE caSync-quotation :
/*------------------------------------------------------------------------------
  Purpose: caSync-quotation
  Parameters:  <none>
  Notes:
------------------------------------------------------------------------------*/

  DEF INPUT PARAMETER piShipment_seqnr     AS INTEGER NO-UNDO.
  DEF INPUT PARAMETER piItem_seqnr         AS INTEGER NO-UNDO.
  DEF INPUT PARAMETER piConnect2Item_seqnr AS INTEGER NO-UNDO.

  DEF VAR iTemporaryKey             AS INTEGER    NO-UNDO.
  DEF VAR cTerminalName1            AS CHARACTER  NO-UNDO.
  DEF VAR cTerminalName2            AS CHARACTER  NO-UNDO.
  DEF VAR cTerminalCode1            AS CHARACTER  NO-UNDO.
  DEF VAR cTerminalCode2            AS CHARACTER  NO-UNDO.
  DEF VAR cQualifier1               AS CHARACTER  NO-UNDO.
  DEF VAR cQualifier2               AS CHARACTER  NO-UNDO.
  DEF VAR lAllConfirmed             AS LOGICAL   NO-UNDO.

  DEFINE VARIABLE i           AS INTEGER NO-UNDO.
  DEFINE VARIABLE lcaTransfer AS LOGICAL NO-UNDO.
  DEFINE VARIABLE lcaQlink    AS LOGICAL NO-UNDO.

  DEF BUFFER b-ca-u_shipment      FOR ca-u_shipment.
  DEF BUFFER b-ca-u_shipment_item FOR ca-u_shipment_item.
  DEF BUFFER b-aa-tp_trip         FOR aa-tp_trip.


  spLogThis ("caSync-quotation", YES /* time */, YES /* skip before */, YES /* skip after */ ).

  /* draait procedure caTransfer ? */
  DO i = 1 TO 99 WHILE PROGRAM-NAME(i) <> ?:
     IF INDEX(PROGRAM-NAME(i),"caTransfer") > 0
     THEN
       lcaTransfer = YES.
     IF INDEX(PROGRAM-NAME(i),"spToolbarQLink") > 0
     THEN
       lcaQlink = YES.
  END.

  IF lcaTransfer OR lcaQlink THEN DO:
/*    MESSAGE "NO caSync-quotation; this is handled by caTransfer & ca-sync-u-shipment-transfer"   view-as alert-box.*/
    RETURN.
  END.

  FOR EACH b-ca-u_shipment_item WHERE
           b-ca-u_shipment_item.companycode    = sp-companycode AND
           b-ca-u_shipment_item.shipment_seqnr = piShipment_seqnr AND
           b-ca-u_shipment_item.item_seqnr     = piItem_seqnr NO-LOCK,
     FIRST b-ca-u_shipment WHERE
           b-ca-u_shipment.companycode    = sp-companycode AND
           b-ca-u_shipment.shipment_seqnr = b-ca-u_shipment_item.shipment_seqnr NO-LOCK:

     IF b-ca-u_shipment.quotation_seqnr           = 0 OR
        b-ca-u_shipment_item.quotation_item_seqnr = 0 THEN NEXT.

     FOR EACH aa-tp_file WHERE
              aa-tp_file.companycode    = sp-companycode AND
              aa-tp_file.shipment_seqnr = b-ca-u_shipment_item.shipment_seqnr  AND
              aa-tp_file.item_seqnr     = piConnect2Item_seqnr NO-LOCK:

       /* Transportfile heeft nog GEEN trips??   */
       IF NOT CAN-FIND (FIRST aa-tp_trip
                        WHERE aa-tp_trip.companycode = sp-companycode
                          AND aa-tp_trip.tp_file_seq = aa-tp_file.tp_file_seqnr
                       /* AND aa-tp_trip.tp_order_seqnr <> 0 */
                          AND aa-tp_trip.tp_trip_seqnr > 0)
       THEN DO:

/*          /* Trips weggooien die er al staan */                            */
/*          FOR EACH aa-tp_trip WHERE                                        */
/*                   aa-tp_trip.companycode = aa-tp_file.companycode AND     */
/*                   aa-tp_trip.tp_file_seqnr = aa-tp_file.tp_file_seqnr AND */
/*                   aa-tp_trip.tp_trip_seqnr > 0:                           */
/*            DELETE aa-tp_trip.                                             */
/*          END.                                                             */

         /* En dan die van de quotation er in */
         FOR EACH ca-quotation
            WHERE ca-quotation.companycode     = sp-companycode
              AND ca-quotation.quotation_seqnr = b-ca-u_shipment.quotation_seqnr NO-LOCK,
            FIRST ca-quotation_item
            WHERE ca-quotation_item.companycode     = sp-companycode
              AND ca-quotation_item.quotation_seqnr = b-ca-u_shipment.quotation_seqnr
              AND ca-quotation_item.item_seqnr      = b-ca-u_shipment_item.quotation_item_seqnr NO-LOCK:

           FIND FIRST ca-service WHERE
                      ca-service.companycode = sp-companycode AND
                      ca-service.servicecode = ca-quotation_item.servicecode NO-LOCK NO-ERROR.

           FOR EACH ca-quotation_trip
              WHERE ca-quotation_trip.companycode = sp-companycode
                AND ca-quotation_trip.quotation_seqnr = ca-quotation_item.quotation_seqnr AND
                    ca-quotation_trip.item_seqnr = ca-quotation_item.item_seqnr
                    NO-LOCK:

             {ca\include\ca-sync_transportplanning_quotationtrip.i}


           END. /* ca-quotation_trip */

         END.  /* ca-quotation */

      END.

    END. /* aa-tp_file */

  END. /* shipment-item  */



  spLogThis ("caSync-quotation done", YES /* time */, YES /* skip before */, YES /* skip after */ ).

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-caSync-ShuntTrip) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE caSync-ShuntTrip Procedure
PROCEDURE caSync-ShuntTrip :
/*------------------------------------------------------------------------------
  Purpose: Determine if we need to create a autogenerated shunt trip
  Parameters:  <none>
  Notes:
------------------------------------------------------------------------------*/
  DEF INPUT PARAMETER piShipment_seqnr     AS INTEGER NO-UNDO.
  DEF INPUT PARAMETER piItem_seqnr         AS INTEGER NO-UNDO.

  DEF VAR iTemporaryKey             AS INTEGER    NO-UNDO.
  DEF VAR cTerminalName1            AS CHARACTER  NO-UNDO.
  DEF VAR cTerminalName2            AS CHARACTER  NO-UNDO.
  DEF VAR cTerminalCode1            AS CHARACTER  NO-UNDO.
  DEF VAR cTerminalCode2            AS CHARACTER  NO-UNDO.
  DEF VAR cQualifier1               AS CHARACTER  NO-UNDO.
  DEF VAR cQualifier2               AS CHARACTER  NO-UNDO.
  DEF VAR lAllConfirmed             AS LOGICAL    NO-UNDO.
  DEF VAR lNeedShuntTrip            AS LOGICAL    NO-UNDO.


  spLogThis (FILL("#",40),  YES /* time */, YES /* skip before */, YES /* skip after */ ).
  spLogThis ("caSyncShunt", YES /* time */, YES /* skip before */, YES /* skip after */ ).

  DEF BUFFER b-ca-u_shipment      FOR ca-u_shipment.
  DEF BUFFER b-ca-u_shipment_item FOR ca-u_shipment_item.

  FOR EACH b-ca-u_shipment_item WHERE
           b-ca-u_shipment_item.companycode    = sp-companycode AND
           b-ca-u_shipment_item.shipment_seqnr = piShipment_seqnr AND
           b-ca-u_shipment_item.item_seqnr     = piItem_seqnr NO-LOCK,
     FIRST b-ca-u_shipment WHERE
           b-ca-u_shipment.companycode    = sp-companycode AND
           b-ca-u_shipment.shipment_seqnr = b-ca-u_shipment_item.shipment_seqnr NO-LOCK,
     FIRST ca-service WHERE
           ca-service.companycode = sp-companycode            AND
           ca-service.servicecode = b-ca-u_shipment.servicecode
           NO-LOCK:


     lNeedShuntTrip = ca-service.ind_transport_shunt.

     /* only do this when no quotation-item is linked (yet) */
     IF b-ca-u_shipment_item.quotation_item_seqnr <> 0 THEN NEXT.

     FOR EACH aa-tp_file WHERE
              aa-tp_file.companycode    = sp-companycode    AND
              aa-tp_file.shipment_seqnr = piShipment_seqnr  AND
              aa-tp_file.item_seqnr     = piItem_seqnr      NO-LOCK:

       FIND FIRST aa-tp_trip WHERE
                  aa-tp_trip.companycode     = aa-tp_file.companycode    AND
                  aa-tp_trip.tp_file_seqnr   = aa-tp_file.tp_file_seqnr AND
                  aa-tp_trip.qualifier       = "SHUNT" AND
                  aa-tp_trip.extra           = "AUTO GENERATED" NO-LOCK NO-ERROR.

       /* No trip avail but we need one */
       IF NOT AVAIL aa-tp_trip AND lNeedShuntTrip
       THEN DO:

         CREATE aa-tp_trip.
         ASSIGN
           aa-tp_trip.companycode     = aa-tp_file.companycode
           aa-tp_trip.tp_trip_seqnr   = NEXT-VALUE(aa-tp_trip)
           aa-tp_trip.tp_file_seqnr   = aa-tp_file.tp_file_seqnr
           aa-tp_trip.qualifier       = "SHUNT"
           aa-tp_trip.tp_trip_status  = "NEW"
           aa-tp_trip.tripnr          = 1
           aa-tp_trip.des             = "Terminal to Terminal (Auto Generated)"
           aa-tp_trip.extra           = "AUTO GENERATED".

        /* MESSAGE "Auto generated shunt trip" VIEW-AS ALERT-BOX INFORMATION. */

       END.
       ELSE DO:

         IF AVAIL aa-tp_trip
         THEN
           FIND CURRENT aa-tp_trip EXCLUSIVE-LOCK NO-WAIT NO-ERROR.

        /* Avail trip, but servicetype determines 'says' we dont need one */
         IF AVAIL aa-tp_trip AND NOT lNeedShuntTrip
         THEN
           DELETE aa-tp_trip.

       END.

       IF NOT lNeedShuntTrip
       THEN NEXT.

       IF AVAIL aa-tp_trip
       THEN DO:

         {ca/include/ca-sync_transportplanning_shunt.i}

       END.


     END. /* each aa-tp_file */

  END. /* shipment/item */

  spLogThis ("caSyncShunt done", YES /* time */, YES /* skip before */, YES /* skip after */ ).

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-caSync-u-shipment) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE caSync-u-shipment Procedure
PROCEDURE caSync-u-shipment :
/*------------------------------------------------------------------------------
  Purpose: caSync-u-shipment
  Parameters:  <none>
  Notes:
------------------------------------------------------------------------------*/
  DEFINE INPUT  PARAMETER piShipment_seqnr AS INTEGER NO-UNDO.
  DEFINE OUTPUT PARAMETER plSyncOK         AS LOGICAL NO-UNDO.

  plSyncOK = YES.

  spLogThis ("caSync-u-shipment", YES /* time */, YES /* skip before */, YES /* skip after */ ).

  FOR EACH ca-u_shipment_item WHERE
           ca-u_shipment_item.companycode    = sp-companycode AND
           ca-u_shipment_item.shipment_seqnr = piShipment_seqnr NO-LOCK:

    RUN caSync-u-shipment-item (ca-u_shipment_item.shipment_seqnr, ca-u_shipment_item.item_seqnr, OUTPUT plSyncOK).
    IF NOT plSyncOK
    THEN LEAVE.

  END.

  spLogThis ("caSync-u-shipment done", YES /* time */, YES /* skip before */, YES /* skip after */ ).


END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-caSync-u-shipment-address) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE caSync-u-shipment-address Procedure
PROCEDURE caSync-u-shipment-address :
/*------------------------------------------------------------------------------
  Purpose: caSync-u-shipment-address
  Parameters:  <none>
  Notes:
------------------------------------------------------------------------------*/
  DEF INPUT PARAMETER piShipment_seqnr          AS INTEGER   NO-UNDO.
  DEF INPUT PARAMETER pcQualifier               AS CHARACTER NO-UNDO.
  DEF INPUT PARAMETER plAutoCreate              AS LOGICAL   NO-UNDO.
  DEF INPUT PARAMETER pcLocationcode            AS CHARACTER NO-UNDO.

  DEF BUFFER b-ca-u_shipment_address FOR ca-u_shipment_address.
  DEF BUFFER b-aa-tp_file            FOR aa-tp_file.
  DEF BUFFER b-consignee             FOR aa-tp_file_address.
  DEF BUFFER b-update-file           FOR aa-tp_file.

  spLogThis ("caSync-u-shipment-address", YES /* time */, YES /* skip before */, YES /* skip after */ ).


  IF pcQualifier <> "BOOKER"    AND
     pcQualifier <> "CONSIGNEE" AND
     pcQualifier <> "SHIPPER"   AND
     INDEX(pcQualifier,"0") = 0 AND
     INDEX(pcQualifier,"9") = 0
  THEN
    RETURN.

  FIND FIRST b-ca-u_shipment_address WHERE
             b-ca-u_shipment_address.companycode = sp-companycode AND
             b-ca-u_shipment_address.shipment_seqnr = piShipment_seqnr AND
             b-ca-u_shipment_address.qualifier = pcQualifier NO-LOCK NO-ERROR.


  FOR EACH b-aa-tp_file WHERE
           b-aa-tp_file.companycode = sp-companycode AND
           b-aa-tp_file.shipment_seqnr = piShipment_seqnr NO-LOCK:

    DO TRANSACTION:

        FIND FIRST b-update-file WHERE ROWID(b-update-file) = ROWID(b-aa-tp_file) EXCLUSIVE-LOCK NO-WAIT NO-ERROR.
        IF NOT AVAIL b-update-file OR LOCKED b-update-file THEN NEXT.

        IF plAutoCreate
        THEN DO:

          FIND FIRST aa-tp_file_address WHERE
                     aa-tp_file_address.companycode   = sp-companycode AND
                     aa-tp_file_address.tp_file_seqnr = b-aa-tp_file.tp_file_seqnr AND
                     aa-tp_file_address.qualifier     = pcQualifier NO-LOCK NO-ERROR.
          IF NOT AVAIL aa-tp_file_address
          THEN DO:
            CREATE aa-tp_file_address.
            ASSIGN aa-tp_file_address.companycode   = sp-companycode
                   aa-tp_file_address.tp_file_seqnr = b-aa-tp_file.tp_file_seqnr
                   aa-tp_file_address.qualifier     = pcQualifier.
          END.
          ELSE
             FIND CURRENT aa-tp_file_address EXCLUSIVE-LOCK NO-WAIT NO-ERROR.
          IF NOT AVAILABLE aa-tp_file_address
          THEN DO:
            ShowMessage("caSync-u-shipment-address","TPfile: " + STRING(b-aa-tp_file.tp_file_seqnr),"Could not autocreate shipment-address " + pcQualifier,"ERROR",NO).
            RETURN "-1".
          END.

          IF pcLocationcode <> ""
          THEN DO:
            FIND FIRST aa-location WHERE
                       aa-location.companycode = sp-companycode AND
                       aa-location.locationcode = pcLocationcode NO-LOCK NO-ERROR.
            IF AVAIL aa-location
            THEN
              ASSIGN
                aa-tp_file_address.city_postalcode = aa-location.city_postalcode
                aa-tp_file_address.addressnr       = aa-location.addressnr
                aa-tp_file_address.NAW             = aa-location.des + " [" + aa-location.portcode + "]".
          END.
          ELSE
            ASSIGN
              aa-tp_file_address.city_postalcode = ""
              aa-tp_file_address.addressnr       = 0
              aa-tp_file_address.NAW             = "".

        END.
        ELSE DO:

          IF NOT AVAIL b-ca-u_shipment_address
          THEN DO:
            ShowMessage("caSync-u-shipment-address","ShipmentSeqnr: " + STRING(piShipment_seqnr),"Could not find shipment address for updating transportfile " + pcQualifier,"ERROR",NO).
            RETURN.
          END.

          FIND FIRST aa-tp_file_address WHERE
                     aa-tp_file_address.companycode   = sp-companycode AND
                     aa-tp_file_address.tp_file_seqnr = b-aa-tp_file.tp_file_seqnr AND
                     aa-tp_file_address.qualifier     = pcQualifier NO-LOCK NO-ERROR.
          IF NOT AVAILABLE aa-tp_file_address
          THEN DO:
            CREATE aa-tp_file_address.
            ASSIGN aa-tp_file_address.companycode   = sp-companycode
                   aa-tp_file_address.tp_file_seqnr = b-aa-tp_file.tp_file_seqnr
                   aa-tp_file_address.qualifier     = pcQualifier.
          END.
          ELSE
             FIND CURRENT aa-tp_file_address EXCLUSIVE-LOCK NO-WAIT NO-ERROR.
          IF NOT AVAILABLE aa-tp_file_address
          THEN DO:
            ShowMessage("caSync-u-shipment-address",
                        "TPfile: " + STRING(b-aa-tp_file.tp_file_seqnr),
                        "Could not update address in transportfile " + pcQualifier,
                        "ERROR",NO).
            RETURN "-1".
          END.

          CASE b-ca-u_shipment_address.qualifier:
            WHEN "BOOKER"    THEN b-update-file.customer_addressnr  = b-ca-u_shipment_address.addressnr.
            WHEN "SHIPPER"   THEN b-update-file.shipper_addressnr   = b-ca-u_shipment_address.addressnr.
            WHEN "CONSIGNEE" THEN b-update-file.consignee_addressnr = b-ca-u_shipment_address.addressnr.
          END CASE.

          IF pcQualifier = "CONSIGNEE"
          THEN DO:
            FIND FIRST b-consignee WHERE
                       b-consignee.companycode = sp-companycode AND
                       b-consignee.tp_file_seqnr = b-aa-tp_file.tp_file_seqnr AND
                       b-consignee.qualifier = "CONSIGNEE" AND
                       b-consignee.extra BEGINS "CONSIGNEE-ITEM" NO-LOCK NO-ERROR.
            IF AVAIL b-consignee
            THEN NEXT.
          END.

          ASSIGN
            aa-tp_file_address.addressnr       = b-ca-u_shipment_address.addressnr
            aa-tp_file_address.contact_e-mail  = b-ca-u_shipment_address.contact_e-mail
            aa-tp_file_address.contact_fax_no  = b-ca-u_shipment_address.contact_fax_no
            aa-tp_file_address.contact_name    = b-ca-u_shipment_address.contact_name
            aa-tp_file_address.contact_tel_no  = b-ca-u_shipment_address.contact_tel_no
            aa-tp_file_address.dt              = b-ca-u_shipment_address.dt
            aa-tp_file_address.tm              = b-ca-u_shipment_address.tm
            aa-tp_file_address.NAW             = b-ca-u_shipment_address.NAW
            aa-tp_file_address.NAW1            = b-ca-u_shipment_address.NAW1.

        END.

    END.


  END.

  spLogThis ("caSync-u-shipment-address done", YES /* time */, YES /* skip before */, YES /* skip after */ ).


END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-caSync-u-shipment-item) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE caSync-u-shipment-item Procedure
PROCEDURE caSync-u-shipment-item :
/*
  Purpose: caSync-u-shipment-item
  Parameters:  <none>
  Notes:
------------------------------------------------------------------------------*/

  DEFINE INPUT  PARAMETER piShipment_seqnr AS INTEGER NO-UNDO.
  DEFINE INPUT  PARAMETER piItem_seqnr     AS INTEGER NO-UNDO.
  DEFINE OUTPUT PARAMETER plSyncOK         AS LOGICAL NO-UNDO.

  DEF BUFFER bMultiItem FOR ca-u_shipment_item.

  DEF VAR iNumVoyageContainers    AS INTEGER   NO-UNDO.
  DEF VAR i                       AS INTEGER   NO-UNDO.
  DEF VAR lTransportFileAanmaken  AS LOGICAL   NO-UNDO.
  DEF VAR piMultiItem_seqnr       AS INTEGER   NO-UNDO.
  DEF VAR iNumTPfiles             AS INTEGER   NO-UNDO.
  DEF VAR pTPRowid                AS ROWID     NO-UNDO.

  DEFINE VAR cCargotype           AS CHARACTER NO-UNDO.
  DEFINE VAR iReeferMin           AS INT       NO-UNDO.
  DEFINE VAR iReeferMax           AS INT       NO-UNDO.
  DEFINE VAR cReeferVentilation   AS CHARACTER NO-UNDO.
  DEFINE VAR cImoClass            AS CHARACTER NO-UNDO.
  DEFINE VAR cImoUNNO             AS CHARACTER NO-UNDO.
  DEFINE VAR cImoMfag             AS CHARACTER NO-UNDO.
  DEFINE VAR cImoEms              AS CHARACTER NO-UNDO.
  DEFINE VAR cImoFlashpoint       AS CHARACTER NO-UNDO.

  DEFINE VAR lHasImo              AS LOGICAL   NO-UNDO.
  DEFINE VAR lHasReefer           AS LOGICAL   NO-UNDO.
  DEFINE VAR lHasWaste            AS LOGICAL   NO-UNDO.

  plSyncOK = YES.

  spLogThis ("caSync-u-shipment-item", YES /* time */, YES /* skip before */, YES /* skip after */ ).

  DEF VAR iPrgIdx AS INT NO-UNDO.
  DO iPrgIdx = 1 TO 6 WHILE PROGRAM-NAME(iPrgIdx) <> ?:
    spLogThis ("call stack(" + string(iPrgIdx) + "): " + PROGRAM-NAME(iPrgIdx), NO,NO,YES).
    IF INDEX(PROGRAM-NAME(iPrgIdx),"dbtrigger") > 0 THEN LEAVE.
  END.


  FIND FIRST ca-u_shipment WHERE
             ca-u_shipment.companycode = sp-companycode AND
             ca-u_shipment.shipment_seqnr = piShipment_seqnr NO-LOCK NO-ERROR.
  IF NOT AVAILABLE ca-u_shipment THEN RETURN.

  FIND FIRST ca-u_shipment_item WHERE
             ca-u_shipment_item.companycode = sp-companycode AND
             ca-u_shipment_item.shipment_seqnr = piShipment_seqnr AND
             ca-u_shipment_item.item_seqnr = piItem_seqnr NO-LOCK NO-ERROR.
  IF NOT AVAILABLE ca-u_shipment_item THEN RETURN.

  iConnect2shipment_item_seqnr = ca-u_shipment_item.item_seqnr.

  iItem-no_of_containers = ca-u_shipment_item.no_of_containers.

  IF  iItem-no_of_containers = -1
  THEN DO:
    /* Split item active, so quit here now */
    RETURN.
 END.

  /* --- */

  RUN GetMultiParameter(piShipment_seqnr, piItem_seqnr, OUTPUT piMultiItem_seqnr, OUTPUT lMulti).

  IF lMulti
  THEN DO:

    iConnect2shipment_item_seqnr = piMultiItem_seqnr.

    IF ca-u_shipment_item.no_of_containers <> 1
    THEN
      ShowMessage("caSync-u-shipment-item",
                  "Shipment: " + STRING(piShipment_seqnr) + CHR(10) +
                  "Item: " + STRING(piItem_seqnr),
                  "Number of containers for this item must be ONE due to use of multi- delivery/receipts","WARNING",NO).

    iItem-no_of_containers = 1. /* always one */

  END.

  /* --- */

  EMPTY TEMP-TABLE ttContainer.

/*   MESSAGE "iConnect2shipment_item_seqnr" iConnect2shipment_item_seqnr VIEW-AS ALERT-BOX.                      */
/*                                                                                                               */
/*   MESSAGE "caSync-u-shipment-item A:" piShipment_seqnr piItem_seqnr iItem-no_of_containers VIEW-AS ALERT-BOX. */
/*                                                                                                               */
  iNumVoyageContainers = 0.

  /* all container of item */
  FOR EACH ca-u_shipment_item_container WHERE
           ca-u_shipment_item_container.companycode    = ca-u_shipment_item.companycode    AND
           ca-u_shipment_item_container.shipment_seqnr = ca-u_shipment_item.shipment_seqnr AND
           ca-u_shipment_item_container.item_seqnr     = iConnect2shipment_item_seqnr      NO-LOCK:

    FOR EACH ca-u_voyage_container WHERE
             ca-u_voyage_container.companycode     = ca-u_shipment.companycode AND
             ca-u_voyage_container.vesselnr        = ca-u_shipment.vesselnr AND
             ca-u_voyage_container.inward-outward  = "o" AND
             ca-u_voyage_container.containerprefix = ca-u_shipment_item_container.containerprefix AND
             ca-u_voyage_container.containernr     = ca-u_shipment_item_container.containernr NO-LOCK:

       /* Container found for transport */
       iNumVoyageContainers = iNumVoyageContainers + 1.

       CREATE ttContainer.
       ASSIGN ttContainer.nr              = iNumVoyageContainers
              ttContainer.containernr     = ca-u_voyage_container.containernr
              ttContainer.containerprefix = ca-u_voyage_container.containerprefix
              ttContainer.containertype   = ca-u_voyage_container.typecode
              ttContainer.sealno          = ca-u_voyage_container.sealno
              ttContainer.ca_container_id = STRING(ca-u_voyage_container.vesselnr) + CHR(1) +
                                            STRING(ca-u_voyage_container.inward-outward) + CHR(1) +
                                            STRING(ca-u_voyage_container.containerprefix) + CHR(1) +
                                            STRING(ca-u_voyage_container.containernr)
              ttContainer.release-pincode = ca-u_voyage_container.release_pincode
              ttContainer.no_packages     = ca-u_shipment_item_container.no_packages
              ttContainer.weight          = ca-u_shipment_item_container.weight
              ttContainer.measurement     = ca-u_shipment_item.measurement.

    END. /* each ca-u_voyage_container */

  END. /* ca-u_shipment_item_container */

  /* How many transportfiles are there already? */
  iNumTPfiles = 0.
  FOR EACH aa-tp_file WHERE
           aa-tp_file.companycode     = ca-u_shipment_item.companycode    AND
           aa-tp_file.shipment_seqnr  = ca-u_shipment_item.shipment_seqnr AND
           aa-tp_file.item_seqnr      = iConnect2shipment_item_seqnr      NO-LOCK:
    iNumTPfiles = iNumTPfiles + 1.
  END.


/*   MESSAGE "caSync-u-shipment-item B:"  piShipment_seqnr piItem_seqnr iNumVoyageContainers VIEW-AS ALERT-BOX.  */


  /* Ok, differences in number of containers ? */
  IF iItem-no_of_containers <> iNumVoyageContainers
  THEN DO:

     /* Need more .. */
     DO i = iNumVoyageContainers + 1 TO iItem-no_of_containers:

       CREATE ttContainer.
       ASSIGN ttContainer.nr = i
              ttContainer.ca_container_id = STRING(ca-u_shipment.vesselnr) + CHR(1) +
                                            "NOTKNOWN" + STRING(i) + CHR(1) +
                                            "" /* containerprefix */ + CHR(1) +
                                            "" /* containernumber */
              ttContainer.containernr     = "????"
              ttContainer.containerprefix = STRING(i)
              ttContainer.containertype   = ca-u_shipment_item.containertypecode
              ttContainer.no_packages     = ca-u_shipment_item.no_packages
              ttContainer.weight          = ca-u_shipment_item.weight
              ttContainer.measurement     = ca-u_shipment_item.measurement.
     END.

  END.

  /* ---------- */

  RUN caSync-GetImoReeferWaste(ca-u_shipment_item.shipment_seqnr,
                               ca-u_shipment_item.item_seqnr,
                               OUTPUT lHasImo,
                               OUTPUT lHasReefer,
                               OUTPUT lHasWaste,

                               OUTPUT cCargotype,
                               OUTPUT iReeferMin,
                               OUTPUT iReeferMax,
                               OUTPUT cReeferVentilation,
                               OUTPUT cImoClass,
                               OUTPUT cImoUNNO,
                               OUTPUT cImoMfag,
                               OUTPUT cImoEms,
                               OUTPUT cImoFlashpoint).

  DO TRANSACTION:

   {ca\include\ca-sync_transportplanning_fixfiles.i}

  END. /* Transaction */


  spLogThis ("caSync-u-shipment-item done", YES /* time */, YES /* skip before */, YES /* skip after */ ).

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-caSync-u-shipment-item-address) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE caSync-u-shipment-item-address Procedure
PROCEDURE caSync-u-shipment-item-address :
/*------------------------------------------------------------------------------
  Purpose: caSync-u-shipment-item-address
  Parameters:  <none>
  Notes:
------------------------------------------------------------------------------*/

  DEFINE INPUT  PARAMETER piShipment_seqnr          AS INTEGER   NO-UNDO.
  DEFINE INPUT  PARAMETER piItem_seqnr              AS INTEGER   NO-UNDO.
  DEFINE INPUT  PARAMETER pcQualifier               AS CHARACTER NO-UNDO.
  DEFINE INPUT  PARAMETER piConnect2Item_seqnr      AS INTEGER   NO-UNDO.
  DEFINE INPUT  PARAMETER plCheckQualifiersNOTUSED  AS LOGICAL   NO-UNDO.
  DEFINE OUTPUT PARAMETER plResultOK                AS LOGICAL   NO-UNDO.

  DEFINE VARIABLE lDeleteAddress   AS LOGICAL   NO-UNDO.
  DEFINE VARIABLE lNewTripsNeeded  AS LOGICAL   NO-UNDO.
  DEFINE VARIABLE lPickAlternative AS LOGICAL   NO-UNDO.
  DEFINE VARIABLE cReasonWhy       AS CHARACTER NO-UNDO.
  DEFINE VARIABLE lQLinkActive     AS LOGICAL   NO-UNDO.

  DEF BUFFER b-ca-u_shipment_item_address FOR ca-u_shipment_item_address.
  DEF BUFFER b-aa-tp_file_address         FOR aa-tp_file_address.
  DEF BUFFER b-aa-tp_file                 FOR aa-tp_file.

  &SCOPED-DEFINE ASK-AND-PICK-ALTERNATIVE ~
      MESSAGE "Address has changed for existing trip" aa-tp_trip.tp_trip_seqnr aa-tp_trip.qualifier aa-tp_trip.des CHR(10) CHR(10) ~
              cReasonWhy CHR(10) CHR(10) ~
              "Please pick alternative route for transportplanning!" ~
              VIEW-AS ALERT-BOX INFORMATION TITLE "Alert". ~
      RUN aa/window/d-route-suggestions-transportfile.p ~
                     (INPUT aa-tp_file_address.tp_file_seqnr, ~
                      0, ~
                      NO, ~
                      aa-tp_trip.qualifier, ~
                      OUTPUT plResultOK ~
                     ).

  plResultOK = YES.
  lNewTripsNeeded = NO.

  IF plCheckQualifiersNOTUSED
  THEN DO:
    MESSAGE "Please NOW sent Softpak the stacktrace from the helpbutton".
  END.


  IF piConnect2Item_seqnr = 0
  THEN
    RUN GetMultiParameter(piShipment_seqnr, piItem_seqnr, OUTPUT piConnect2Item_seqnr, OUTPUT lMulti).

  FIND FIRST b-ca-u_shipment_item_address WHERE
             b-ca-u_shipment_item_address.companycode = sp-companycode AND
             b-ca-u_shipment_item_address.shipment_seqnr = piShipment_seqnr AND
             b-ca-u_shipment_item_address.item_seqnr = piItem_seqnr AND
             b-ca-u_shipment_item_address.qualifier = pcQualifier NO-LOCK NO-ERROR.

  FOR EACH b-aa-tp_file WHERE
           b-aa-tp_file.companycode    = sp-companycode AND
           b-aa-tp_file.shipment_seqnr = piShipment_seqnr AND
           b-aa-tp_file.item_seqnr     = piConnect2Item_seqnr NO-LOCK:

    FIND FIRST aa-tp_file_address WHERE
               aa-tp_file_address.companycode   = sp-companycode AND
               aa-tp_file_address.tp_file_seqnr = b-aa-tp_file.tp_file_seqnr AND
               aa-tp_file_address.item_seqnr    = (IF pcQualifier = "CONSIGNEE" THEN 0 ELSE piConnect2Item_seqnr) AND
               aa-tp_file_address.qualifier     = pcQualifier NO-LOCK NO-ERROR.

    IF NOT AVAILABLE aa-tp_file_address
    THEN DO:

      /* Check if we already have the qualifier in this transportfile */
      FIND FIRST aa-tp_file_address WHERE
                 aa-tp_file_address.companycode   = sp-companycode AND
                 aa-tp_file_address.tp_file_seqnr = b-aa-tp_file.tp_file_seqnr AND
                 aa-tp_file_address.qualifier     = pcQualifier NO-LOCK NO-ERROR.

      /* IF AVAIL then geen nieuwe maken met zelfde qualifier; vind unieke index niet leuk ... */
      IF AVAIL aa-tp_file_address
      THEN DO:
        ShowMessage("caSync-u-shipment-item-address",
                    "Bookingnr" + b-aa-tp_file.bookingnr,
                    "Could not create another unique address " + STRING(b-aa-tp_file.tp_file_seqnr) + " " + pcQualifier +
                    chr(10) + chr(10) + "Use different qualifier!","ERROR",NO).
        RETURN.
      END.

      CREATE aa-tp_file_address.
      ASSIGN aa-tp_file_address.companycode   = sp-companycode
             aa-tp_file_address.tp_file_seqnr = b-aa-tp_file.tp_file_seqnr
             aa-tp_file_address.item_seqnr    = (IF pcQualifier = "CONSIGNEE" THEN 0 ELSE piConnect2Item_seqnr)
             aa-tp_file_address.qualifier     = pcQualifier.

    END.
    ELSE
      FIND CURRENT aa-tp_file_address EXCLUSIVE-LOCK NO-WAIT NO-ERROR.
    IF NOT AVAILABLE aa-tp_file_address
    THEN DO:
      ShowMessage("caSync-u-shipment-item-address",
                  "Bookingnr" + b-aa-tp_file.bookingnr,
                  "Could not update address " + pcQualifier,"ERROR",NO).
      RETURN "-1".
    END.


    IF pcQualifier = "CONSIGNEE"
    THEN
      aa-tp_file_address.extra = "CONSIGNEE-ITEM/" + STRING(piConnect2Item_seqnr).


    ASSIGN
      aa-tp_file_address.addressnr       = b-ca-u_shipment_item_address.addressnr
      aa-tp_file_address.city_postalcode = b-ca-u_shipment_item_address.city_postalcode
      aa-tp_file_address.contact_e-mail  = b-ca-u_shipment_item_address.contact_e-mail
      aa-tp_file_address.contact_fax_no  = b-ca-u_shipment_item_address.contact_fax_no
      aa-tp_file_address.contact_name    = b-ca-u_shipment_item_address.contact_name
      aa-tp_file_address.contact_tel_no  = b-ca-u_shipment_item_address.contact_tel_no
      aa-tp_file_address.NAW             = b-ca-u_shipment_item_address.NAW
      aa-tp_file_address.NAW1            = b-ca-u_shipment_item_address.NAW1
      aa-tp_file_address.remarks         = b-ca-u_shipment_item_address.remarks.

    IF /* NOT aa-tp_file_address.ind_confirmed AND */ b-ca-u_shipment_item_address.dt <> ?
    THEN
      ASSIGN
        aa-tp_file_address.dt            = b-ca-u_shipment_item_address.dt
        aa-tp_file_address.tm            = b-ca-u_shipment_item_address.tm
        aa-tp_file_address.tm_till       = b-ca-u_shipment_item_address.tm_till.

    IF SUBSTRING(pcQualifier,1,4) <> "LOAD" AND
       SUBSTRING(pcQualifier,1,4) <> "DELI"
    THEN RETURN. /* Done here */

    /* ---------- */

    FIND FIRST aa-tp_move WHERE
               aa-tp_move.companycode = sp-companycode AND
               aa-tp_move.tp_file_seqnr = b-aa-tp_file.tp_file_seqnr AND
               aa-tp_move.from_qualifier = aa-tp_file_address.qualifier NO-LOCK NO-ERROR.

    IF AVAILABLE aa-tp_move
    THEN DO:

      FIND FIRST aa-tp_trip WHERE
                 aa-tp_trip.companycode = aa-tp_move.companycode AND
                 aa-tp_trip.tp_trip_seqnr = aa-tp_move.tp_trip_seqnr NO-LOCK NO-ERROR.
      IF aa-tp_trip.tp_trip_seqnr > 0
      THEN DO:

        FIND CURRENT aa-tp_move EXCLUSIVE-LOCK NO-WAIT NO-ERROR.
        IF aa-tp_move.from_type = "P"
        THEN DO:

          IF aa-tp_move.from_code <> "" AND
             aa-tp_move.from_code <> aa-tp_file_address.city_postalcode
          THEN DO:
            lNewTripsNeeded = YES.
            cReasonWhy = "[OLD] move/from = " + aa-tp_move.from_code + " - [NEW] address/city_postalcode = " + aa-tp_file_address.city_postalcode.
          END.

          ASSIGN
            aa-tp_move.zip1             = aa-tp_file_address.city_postalcode
            aa-tp_move.from_code        = aa-tp_file_address.city_postalcode.
        END.

        IF aa-tp_trip.qualifier = "COLLECTION"
        THEN
          ASSIGN
            aa-tp_move.dt_requested       = aa-tp_file_address.dt
            aa-tp_move.tim_requested      = aa-tp_file_address.tm
            aa-tp_move.tim_requested_till = aa-tp_file_address.tm_till.

      END. /* trip_seqnr > 0 */

    END. /* avail move */

    /* ---------- */

    FIND FIRST aa-tp_move WHERE
               aa-tp_move.companycode = sp-companycode AND
               aa-tp_move.tp_file_seqnr = b-aa-tp_file.tp_file_seqnr AND
               aa-tp_move.to_qualifier = aa-tp_file_address.qualifier NO-LOCK NO-ERROR.
    IF AVAILABLE aa-tp_move
    THEN DO:

      FIND FIRST aa-tp_trip WHERE
                 aa-tp_trip.companycode = aa-tp_move.companycode AND
                 aa-tp_trip.tp_trip_seqnr = aa-tp_move.tp_trip_seqnr NO-LOCK NO-ERROR.
      IF aa-tp_trip.tp_trip_seqnr > 0
      THEN DO:

        FIND CURRENT aa-tp_move EXCLUSIVE-LOCK NO-WAIT NO-ERROR.
        IF aa-tp_move.to_type = "P"
        THEN DO:

          IF aa-tp_move.to_code <> "" AND
             aa-tp_move.to_code <> aa-tp_file_address.city_postalcode
          THEN DO:
            lNewTripsNeeded = YES.
            cReasonWhy = cReasonWhy + (IF cReasonWhy <> "" THEN CHR(10) ELSE "") +
                         "[OLD] move/to = " + aa-tp_move.to_code + " - [NEW] address/city_postalcode = " + aa-tp_file_address.city_postalcode.
          END.

          ASSIGN
            aa-tp_move.zip2             = aa-tp_file_address.city_postalcode
            aa-tp_move.to_code          = aa-tp_file_address.city_postalcode.
        END.

        IF aa-tp_trip.qualifier = "DELIVERY"
        THEN
          ASSIGN
            aa-tp_move.dt_requested       = aa-tp_file_address.dt
            aa-tp_move.tim_requested      = aa-tp_file_address.tm
            aa-tp_move.tim_requested_till = aa-tp_file_address.tm_till.

      END. /* tp_trip_seqnr > 0 */

    END. /* avail aa-tp_move */

    IF lNewTripsNeeded
    THEN DO:

      lQLinkActive = NO.
      DO iPrgIdx = 1 TO 99 WHILE PROGRAM-NAME(iPrgIdx) <> ?:
        IF INDEX(PROGRAM-NAME(iPrgIdx),"spToolbarQLink") > 0
        THEN DO:
          lQLinkActive = YES.
          LEAVE.
        END.
      END.

      IF glSchedulerActive OR lQLinkActive
      THEN DO:
        ShowMessage("caSync-u-shipment-item-address",
                    "Bookingnr" + b-aa-tp_file.bookingnr,
                    "Address has been changed for existing trip " + STRING(aa-tp_trip.tp_trip_seqnr) + " " + aa-tp_trip.qualifier + " - " + aa-tp_trip.des + CHR(10) + CHR(10) +
                    cReasonWhy + CHR(10) + CHR(10) +
                    "Please pick alternative route for transportplanning!","ERROR",lQLinkActive).

      END.
      ELSE DO:

        {&ASK-AND-PICK-ALTERNATIVE}

      END.

    END.

  END. /* each b-aa-tp_file */


END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-caSync-u-shipment-item-address-q) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE caSync-u-shipment-item-address-q Procedure
PROCEDURE caSync-u-shipment-item-address-q :
/*------------------------------------------------------------------------------
  Purpose: caSync-u-shipment-item-address-q
  Parameters:  <none>
  Notes:
------------------------------------------------------------------------------*/

  DEF INPUT PARAMETER piShipment_seqnr          AS INTEGER   NO-UNDO.
  DEF INPUT PARAMETER piItem_seqnr              AS INTEGER   NO-UNDO.
  DEF INPUT PARAMETER pcQualifier               AS CHARACTER NO-UNDO.

  DEF VAR cOldQualifier       AS CHAR NO-UNDO.
  DEF VAR cNewQualifier       AS CHAR NO-UNDO.
  DEF VAR lMulti              AS LOG  NO-UNDO.
  DEF VAR iConnect2Item_seqnr AS INT NO-UNDO.

  DEF BUFFER b-aa-tp_file                 FOR aa-tp_file.
  DEF BUFFER b-ca-u_shipment_item_address FOR ca-u_shipment_item_address.
  DEF BUFFER b-aa-tp_file_address         FOR aa-tp_file_address.
  DEF BUFFER b-ca-u_shipment              FOR ca-u_shipment.

  ASSIGN
    cOldQualifier = ENTRY(1, pcQualifier, "/")
    cNewQualifier = ENTRY(2, pcQualifier, "/").

  RUN GetMultiParameter(piShipment_seqnr, piItem_seqnr, OUTPUT iConnect2Item_seqnr, OUTPUT lMulti).

  IF NOT lMulti
  THEN
    iConnect2Item_seqnr = piItem_seqnr.

  FOR EACH b-aa-tp_file WHERE
           b-aa-tp_file.companycode    = sp-companycode AND
           b-aa-tp_file.shipment_seqnr = piShipment_seqnr AND
           b-aa-tp_file.item_seqnr     = iConnect2Item_seqnr NO-LOCK:

    DO TRANSACTION:

      FIND FIRST aa-tp_file_address WHERE
                 aa-tp_file_address.companycode   = sp-companycode AND
                 aa-tp_file_address.tp_file_seqnr = b-aa-tp_file.tp_file_seqnr AND
                 aa-tp_file_address.item_seqnr    = iConnect2Item_seqnr AND
                 aa-tp_file_address.qualifier     = cOldQualifier EXCLUSIVE-LOCK NO-WAIT NO-ERROR.
      IF NOT AVAILABLE aa-tp_file_address
      THEN DO:
        ShowMessage("caSync-u-shipment-item-address-q",
                    "TPfile: " + STRING(b-aa-tp_file.tp_file_seqnr),
                    "Alert! Could not update transportfile address from qualifier " + cOldQualifier + " TO " + cNewQualifier,"ERROR",NO).
        RETURN.
      END.

      aa-tp_file_address.qualifier = cNewQualifier.

    END.

  END.

  FOR EACH b-aa-tp_file WHERE
           b-aa-tp_file.companycode    = sp-companycode AND
           b-aa-tp_file.shipment_seqnr = piShipment_seqnr AND
           b-aa-tp_file.item_seqnr     = iConnect2Item_seqnr NO-LOCK,
      EACH aa-tp_file_address WHERE
           aa-tp_file_address.companycode   = sp-companycode AND
           aa-tp_file_address.tp_file_seqnr = b-aa-tp_file.tp_file_seqnr AND
           aa-tp_file_address.qualifier    <> cNewQualifier NO-LOCK:

    IF aa-tp_file_address.qualifier = "BOOKER" OR
       aa-tp_file_address.qualifier = "SHIPPER" OR
       aa-tp_file_address.qualifier = "CONSIGNEE" OR
       aa-tp_file_address.qualifier = "DEBTOR" OR
       aa-tp_file_address.qualifier = "FORWARDER" OR
       aa-tp_file_address.qualifier = "AGENT POD" OR
       INDEX(aa-tp_file_address.qualifier," 0") > 0 OR
       INDEX(aa-tp_file_address.qualifier," 9") > 0
    THEN NEXT.

    FIND FIRST b-ca-u_shipment_item_address WHERE
               b-ca-u_shipment_item_address.companycode = sp-companycode AND
               b-ca-u_shipment_item_address.shipment_seqnr = piShipment_seqnr AND
               b-ca-u_shipment_item_address.item_seqnr = piItem_seqnr AND
               b-ca-u_shipment_item_address.qualifier = aa-tp_file_address.qualifier NO-LOCK NO-ERROR.
    IF NOT AVAIL b-ca-u_shipment_item_address
    THEN DO:

      /* Dit adres kunnen we niet vinden in, gekoppeld aan shipment item */
      /* Maar misschien is dit een multi delivery/collection, dus dan ook nog zoeken zonder item-seqnr */

      FIND FIRST b-ca-u_shipment WHERE
                 b-ca-u_shipment.companycode = sp-companycode AND
                 b-ca-u_shipment.shipment_seqnr = piShipment_seqnr NO-LOCK NO-ERROR.

      IF (b-ca-u_shipment.ind_multi_receipt  AND SUBSTRING(aa-tp_file_address.qualifier,1,7) = "LOADING") OR
         (b-ca-u_shipment.ind_multi_delivery AND SUBSTRING(aa-tp_file_address.qualifier,1,8) = "DELIVERY")
      THEN
        FIND FIRST b-ca-u_shipment_item_address WHERE
                   b-ca-u_shipment_item_address.companycode = sp-companycode AND
                   b-ca-u_shipment_item_address.shipment_seqnr = piShipment_seqnr AND
                   b-ca-u_shipment_item_address.qualifier = aa-tp_file_address.qualifier NO-LOCK NO-ERROR.

      IF NOT AVAIL b-ca-u_shipment_item_address
      THEN DO:

        IF NOT glSchedulerActive
        THEN DO:
            MESSAGE "Alert!" CHR(10) CHR(10) "There is an address with qualifier" aa-tp_file_address.qualifier
                    "in this transportfile... but not in the shipment!" CHR(10) CHR(10)
                    "Do you want to keep this address?"
               VIEW-AS ALERT-BOX QUESTION BUTTONS YES-NO-CANCEL UPDATE lKeepIt AS LOGICAL.

            IF lKeepIt = NO
            THEN DO:
              FIND FIRST b-aa-tp_file_address WHERE ROWID(aa-tp_file_address) = ROWID(b-aa-tp_file_address)
                EXCLUSIVE-LOCK NO-WAIT NO-ERROR.
              IF AVAIL b-aa-tp_file_address
              THEN DELETE b-aa-tp_file_address.
              ELSE MESSAGE "Could not update transportfile/addresses. Check addresses!"
                VIEW-AS ALERT-BOX WARNING.
           END.
        END.
        ELSE
          ShowMessage("caSync-u-shipment-item-address-q",
                      "TPfile: " + STRING(b-aa-tp_file.tp_file_seqnr),
                      "There is an address with qualifier " + aa-tp_file_address.qualifier +
                      " in this transportfile... but not in the shipment!","",NO).

      END.

    END.

  END.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-caSync-u-shipment-item-container-d) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE caSync-u-shipment-item-container-d Procedure
PROCEDURE caSync-u-shipment-item-container-d :
/*------------------------------------------------------------------------------
  Purpose:
  Parameters:  <none>
  Notes:
------------------------------------------------------------------------------*/
  DEF INPUT PARAMETER piShipment_seqnr    AS INTEGER   NO-UNDO.
  DEF INPUT PARAMETER piItem_seqnr        AS INTEGER   NO-UNDO.
  DEF INPUT PARAMETER pcContainerPrefix   AS CHARACTER NO-UNDO.
  DEF INPUT PARAMETER pcContainerNr       AS CHARACTER NO-UNDO.
  DEF INPUT PARAMETER pcWhat              AS CHARACTER NO-UNDO.


  FOR EACH aa-tp_file WHERE
           aa-tp_file.companycode     = sp-companycode     AND
           aa-tp_file.shipment_seqnr  = piShipment_seqnr    AND
           aa-tp_file.item_seqnr      = piItem_seqnr        AND
           aa-tp_file.containerprefix = pcContainerPrefix   AND
           aa-tp_file.containernr     = pcContainerNr       :

    aa-tp_file.containerprefix = "".
    aa-tp_file.containernr     = "????".

  END.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-caSync-u-shipment-transfer) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE caSync-u-shipment-transfer Procedure
PROCEDURE caSync-u-shipment-transfer :
/*------------------------------------------------------------------------------
  Purpose:
  Parameters:  <none>
  Notes:
------------------------------------------------------------------------------*/

  DEF INPUT PARAMETER piShipment_seqnr AS INTEGER NO-UNDO.
  DEF INPUT PARAMETER pcTransferInfo   AS CHAR NO-UNDO.

/*   MESSAGE "caSync-u-shipment-transfer(" piShipment_seqnr "," pcTransferInfo ")".  */

  DEF BUFFER b-aa-tp_trip FOR aa-tp_trip.

  DEF VARIABLE lHasUnplannedTripsOnly AS LOGICAL   NO-UNDO.
  DEF VARIABLE lPickedRoute           AS LOGICAL   NO-UNDO.
  DEF VARIABLE cQualifierTrip         AS CHARACTER NO-UNDO.


  /* draait programma vanuit scheduler? */
  DEF VAR lSchedulerActive AS LOGICAL NO-UNDO.
  DEF VAR iPrgIdx AS INTEGER NO-UNDO.

  lSchedulerActive = NO.
  DO iPrgIdx = 1 TO 99 WHILE PROGRAM-NAME(iPrgIdx) <> ?:
     IF INDEX(PROGRAM-NAME(iPrgIdx),"w-aa-scheduler") > 0
     THEN DO:
       lSchedulerActive = YES.
       LEAVE.
     END.
  END.
  IF lSchedulerActive
  THEN RETURN.

  FIND FIRST ca-u_shipment WHERE
             ca-u_shipment.companycode = sp-companycode AND
             ca-u_shipment.shipment_seqnr = piShipment_seqnr NO-LOCK NO-ERROR.
  IF NOT AVAILABLE ca-u_shipment THEN RETURN.

  FOR EACH aa-tp_file WHERE
           aa-tp_file.companycode     = ca-u_shipment.companycode    AND
           aa-tp_file.shipment_seqnr  = ca-u_shipment.shipment_seqnr NO-LOCK:

    /* Trips aanwezig? */
    IF NOT CAN-FIND (FIRST aa-tp_trip WHERE
                           aa-tp_trip.companycode   = aa-tp_file.companycode AND
                           aa-tp_trip.tp_file_seqnr = aa-tp_file.tp_file_seqnr AND
                           aa-tp_trip.tp_trip_seqnr > 0)
    THEN
      NEXT.

    lHasUnplannedTripsOnly = YES.

    trip:
    FOR EACH aa-tp_trip WHERE
             aa-tp_trip.companycode   = aa-tp_file.companycode AND
             aa-tp_trip.tp_file_seqnr = aa-tp_file.tp_file_seqnr AND
             aa-tp_trip.tp_trip_seqnr > 0 NO-LOCK:

      /* ---------------------------------------------------------------------------------------- */
      /* pcTransferInfo   contains info about which trips are involved in the shipment's transfer */
      /* ---------------------------------------------------------------------------------------- */

      IF pcTransferInfo <> "COLLECTION+DELIVERY" /* = which means all trips */
      THEN DO:

        /* If TRANSFER or FEEDER, check moves to determine if this is DEL or COLL */
        IF aa-tp_trip.qualifier <> "DELIVERY"   AND
           aa-tp_trip.qualifier <> "COLLECTION"
        THEN DO:

          FIND FIRST aa-tp_move WHERE
                     aa-tp_move.companycode = aa-tp_trip.companycode AND
                     aa-tp_move.tp_trip_seqnr = aa-tp_trip.tp_trip_seqnr NO-LOCK NO-ERROR.
          IF NOT AVAIL aa-tp_move
          THEN NEXT trip. /* empty trip */

          cQualifierTrip = "".
          IF aa-tp_move.delivery_collection = "D"
          THEN
            cQualifierTrip = "DELIVERY".
          ELSE
            IF aa-tp_move.delivery_collection = "C"
            THEN
              cQualifierTrip = "COLLECTION".

        END.
        ELSE
          cQualifierTrip = aa-tp_trip.qualifier.

        IF pcTransferInfo = "DELIVERY" AND cQualifierTrip = "COLLECTION"
        THEN NEXT trip. /* deliveries only */

        IF pcTransferInfo = "COLLECTION" AND cQualifierTrip = "DELIVERY"
        THEN NEXT trip. /* collections only */

      END.
   /* ELSE means all trips */


      /* ------------------------------------------------------------------------- */
      /* So now, this trip has to be adjusted, due to change or POD or POL etc     */
      /* ------------------------------------------------------------------------- */
      DO TRANSACTION:

         FIND FIRST b-aa-tp_trip WHERE
              ROWID(b-aa-tp_trip) = ROWID(aa-tp_trip) EXCLUSIVE-LOCK NO-ERROR.
         IF NOT AVAIL b-aa-tp_trip
         THEN DO:
           ShowMessage("caSync-u-shipment-transfer",
                       "Trip: " + STRING(aa-tp_trip.tp_trip_seqnr),
                       "ALERT: cannot update status trip (SHIPMENT TRANSFERRED) " + STRING(aa-tp_trip.tp_trip_seqnr),"ERROR",NO).
           NEXT.
         END.

         IF aa-tp_trip.tp_order_seqnr <> 0
         THEN DO:

           ASSIGN
             lHasUnplannedTripsOnly      = NO
             b-aa-tp_trip.tp_trip_status = "TRANSFERRED!".

         END.

     END. /* transaction */

   END. /* each trip */

   /* ----------------------------------------------------------------------- */

   IF lHasUnplannedTripsOnly
   THEN DO:

     MESSAGE "Routing transportfile" aa-tp_file.tp_file_seq "is probably not valid anymore, " CHR(10)
             "we will now start RouteSuggestions for" pcTransferInfo CHR(10) CHR(10)
             "Please choose correct route!"
        VIEW-AS ALERT-BOX WARNING.

     RUN aa/window/d-route-suggestions-transportfile.p
                  (aa-tp_file.tp_file_seq,
                   0,
                   YES, /* transfer */
                   pcTransferInfo, /* no qualifier filter */
                   OUTPUT lPickedRoute
                   ).
     IF NOT lPickedRoute
     THEN
       MESSAGE "Please check routing for transportfile" aa-tp_file.tp_file_seq VIEW-AS ALERT-BOX WARNING.

   END.
   ELSE DO:

     lPickedRoute = NO.

     IF pcTransferInfo <> "XX"
     THEN DO:

       MESSAGE "Routing transportfile" aa-tp_file.tp_file_seq "is probably not valid anymore for " pcTransferInfo CHR(10)
               "we will now start RouteSuggestions for an alternative." CHR(10) CHR(10)
               "Please adjust route!"
          VIEW-AS ALERT-BOX WARNING.

       RUN aa/window/d-route-suggestions-transportfile.p
                    (aa-tp_file.tp_file_seq,
                     0,
                     YES,
                     pcTransferInfo,
                     OUTPUT lPickedRoute
                     ).

       IF NOT lPickedRoute
       THEN
         MESSAGE "ALERT! Please check routing for transportfile" aa-tp_file.tp_file_seq "for" pcTransferInfo "!"
            VIEW-AS ALERT-BOX WARNING.

     END.
     ELSE
     /* else do nothing, just show message */
       MESSAGE "ALERT! Please check routing for transportfile" aa-tp_file.tp_file_seq "!" CHR(10) CHR(10)
               "Planned trips are involved here!"
          VIEW-AS ALERT-BOX WARNING.

   END.

  END. /* each transportfile */

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-caSync-u-voyage) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE caSync-u-voyage Procedure
PROCEDURE caSync-u-voyage :
/*------------------------------------------------------------------------------
  Purpose: caSync-u-voyage
  Parameters:  <none>
  Notes:
------------------------------------------------------------------------------*/

  DEF INPUT PARAMETER piVesselnr                AS INTEGER   NO-UNDO.
  DEF INPUT PARAMETER pRowidShipment            AS ROWID     NO-UNDO.

  DEF BUFFER b-ca-u_shipment       FOR ca-u_shipment.
  DEF BUFFER b-ca-u_shipment_item  FOR ca-u_shipment_item.
  DEF BUFFER b-aa-tp_file          FOR aa-tp_file.
  DEF BUFFER b-aa-tp_trip          FOR aa-tp_trip.
  DEF BUFFER bTripBeforeThisOne    FOR aa-tp_trip.
  DEF BUFFER b-update-file FOR aa-tp_file.


  DEF VAR cTIM_ETS       AS CHARACTER NO-UNDO.
  DEF VAR cTIM_ETA       AS CHARACTER NO-UNDO.
  DEF VAR dETS           AS DATE      NO-UNDO.
  DEF VAR dETA           AS DATE      NO-UNDO.
  DEF VAR cDes           AS CHARACTER NO-UNDO.
  DEF VAR dClosing       AS DATE      NO-UNDO.
  DEF VAR cTIM_closing   AS CHARACTER NO-UNDO.
  DEF VAR dAvailable     AS DATE      NO-UNDO.
  DEF VAR cTIM_available AS CHARACTER NO-UNDO.
  DEF VAR cVoynoOut      AS CHARACTER NO-UNDO.

  DEFINE VARIABLE iAccYear   AS INTEGER NO-UNDO.
  DEFINE VARIABLE iAccPeriod AS INTEGER NO-UNDO.

  IF piVesselnr = 0 THEN RETURN.

  FOR EACH b-ca-u_shipment WHERE
           b-ca-u_shipment.companycode = sp-companycode AND
           b-ca-u_shipment.vesselnr    = piVesselnr USE-INDEX vessel-bookingnr NO-LOCK:

    /* wanneer gestart vanuit shipment_item */
    IF pRowidShipment <> ?
    THEN IF ROWID(b-ca-u_shipment) <> pRowidShipment THEN NEXT.

    FOR EACH b-aa-tp_file WHERE
             b-aa-tp_file.companycode    = sp-companycode AND
             b-aa-tp_file.shipment_seqnr = b-ca-u_shipment.shipment_seqnr NO-LOCK USE-INDEX shipment:

      ASSIGN
         cTIM_ETS       = ""
         cTIM_ETA       = ""
         cTIM_closing   = ""
         cTIM_available = ""
         dAvailable     = ?
         dClosing       = ?
         dETS           = ?
         dETA           = ?
         cDes           = ""
         iAccYear       = 0
         iAccPeriod     = 0.

      FIND FIRST aa-vessel OF b-ca-u_shipment NO-LOCK NO-ERROR.
      cDes = aa-vessel.des.
      cVoynoOut = aa-vessel.voyno_out.

      IF b-ca-u_shipment.locationcode <> ""
      THEN DO:
        FIND FIRST ca-u_vessel_pol_terminal WHERE
                   ca-u_vessel_pol_terminal.companycode  = b-ca-u_shipment.companycode AND
                   ca-u_vessel_pol_terminal.vesselnr     = b-ca-u_shipment.vesselnr AND
                   ca-u_vessel_pol_terminal.pol_portcode = b-ca-u_shipment.pol_portcode AND
                   ca-u_vessel_pol_terminal.locationcode = b-ca-u_shipment.locationcode NO-LOCK NO-ERROR.
        IF NOT AVAILABLE ca-u_vessel_pol_terminal
        THEN.
        /*
          MESSAGE "Could not find POL-terminal (" b-ca-u_shipment.vesselnr b-ca-u_shipment.pol_portcode b-ca-u_shipment.locationcode ") in voyage" VIEW-AS ALERT-BOX TITLE "Sync transportportplanning".
         */
        ELSE
          ASSIGN
            cTIM_ETS          = ca-u_vessel_pol_terminal.time_ets
            dETS              = ca-u_vessel_pol_terminal.dt_ets
            cTIM_closing      = ca-u_vessel_pol_terminal.tim_closing
            dClosing          = ca-u_vessel_pol_terminal.dt_closing.
      END.

      IF b-ca-u_shipment.pod_locationcode <> ""
      THEN DO:
        FIND FIRST ca-u_vessel_pod_terminal WHERE
                   ca-u_vessel_pod_terminal.companycode  = b-ca-u_shipment.companycode AND
                   ca-u_vessel_pod_terminal.vesselnr     = b-ca-u_shipment.vesselnr AND
                   ca-u_vessel_pod_terminal.pod_portcode = b-ca-u_shipment.pod_portcode AND
                   ca-u_vessel_pod_terminal.locationcode = b-ca-u_shipment.pod_locationcode NO-LOCK NO-ERROR.
        IF NOT AVAILABLE ca-u_vessel_pod_terminal
        THEN.
        /*
          MESSAGE "Could not find POD-terminal (" b-ca-u_shipment.vesselnr b-ca-u_shipment.pod_portcode b-ca-u_shipment.pod_locationcode ") in voyage" VIEW-AS ALERT-BOX TITLE "Sync transportportplanning".
         */
        ELSE
          ASSIGN
            cTIM_ETA       = ca-u_vessel_pod_terminal.time_eta
            dETA           = ca-u_vessel_pod_terminal.dt_eta
            cTIM_available = ca-u_vessel_pod_terminal.time_available
            dAvailable     = ca-u_vessel_pod_terminal.dt_available.
      END.

      /* ----------------------- */

      DO TRANSACTION:

          FIND FIRST b-update-file WHERE ROWID(b-update-file) = ROWID(b-aa-tp_file) EXCLUSIVE-LOCK NO-WAIT NO-ERROR.
          IF AVAIL b-update-file
          THEN DO:

            ASSIGN
              b-update-file.voyage_tim_ets  = cTIM_ETS
              b-update-file.voyage_tim_eta  = cTIM_ETA
              b-update-file.voyage_dt_ets   = dETS
              b-update-file.voyage_dt_eta   = dETA
              b-update-file.voyage_des      = cDes
              b-update-file.voyno_out       = cVoynoOut
              b-update-file.acc_year        = iAccYear
              b-update-file.acc_period      = iAccPeriod
              .

          END.
          ELSE DO:

          END.

      END.

      /* trigger uit; die komt nog voorbij vanuit catchchange vanuit aa-tp_file trigger */
      ON WRITE OF aa-tp_trip OVERRIDE DO: END.

      FOR EACH b-aa-tp_trip WHERE
               b-aa-tp_trip.companycode   = b-aa-tp_file.companycode AND
               b-aa-tp_trip.tp_file_seqnr = b-aa-tp_file.tp_file_seqnr NO-LOCK:

        DO TRANSACTION:

            FIND FIRST aa-tp_trip WHERE ROWID(aa-tp_trip) = ROWID(b-aa-tp_trip) EXCLUSIVE-LOCK NO-WAIT NO-ERROR.
            IF NOT AVAIL aa-tp_trip OR LOCKED aa-tp_trip
            THEN
              NEXT.

            FIND FIRST b-ca-u_shipment_item WHERE
                       b-ca-u_shipment_item.companycode    = b-aa-tp_file.companycode AND
                       b-ca-u_shipment_item.shipment_seqnr = b-aa-tp_file.shipment_seqnr AND
                       b-ca-u_shipment_item.item_seqnr     = b-aa-tp_file.item_seqnr NO-LOCK NO-ERROR.


            IF aa-tp_trip.qualifier = "DELIVERY" AND aa-tp_trip.startpoint_type = "VOYAGE"
            THEN
              ASSIGN
                aa-tp_trip.startpoint_location = b-ca-u_shipment.pod_locationcode
                aa-tp_trip.dt_available        = dAvailable
                aa-tp_trip.tim_available       = cTIM_available.


            IF aa-tp_trip.dt_requested = ? AND aa-tp_trip.qualifier = "TRANSFER"
            THEN DO:

              /* Even de 1e move pakken om te zien of we in een delivery zitten of collection */
              FIND FIRST aa-tp_move WHERE
                         aa-tp_move.companycode = aa-tp_trip.companycode AND
                         aa-tp_move.tp_trip_seqnr = aa-tp_trip.tp_trip_seqnr NO-LOCK NO-ERROR.
              IF AVAILABLE aa-tp_move
              THEN DO:

                IF aa-tp_trip.startpoint_type = "VOYAGE"
                THEN DO:
                  /* Rail/Barge: when starting from voyage; and delivery; fill requested date with date available */
                  aa-tp_trip.dt_requested = (IF dAvailable <> ? THEN dAvailable ELSE dETA).
                END.
                ELSE
                  IF aa-tp_move.delivery_collection = "C"
                  THEN DO:

                    /* Rail/Barge: when part of collection; difficult to determine date.. so take date from previous trip */
                    IF aa-tp_trip.qualifier = "TRANSFER"
                    THEN DO:
                      FIND FIRST bTripBeforeThisOne WHERE
                                 bTripBeforeThisOne.companycode = aa-tp_trip.companycode AND
                                 bTripBeforeThisOne.tp_file_seqnr = aa-tp_trip.tp_file_seqnr AND
                                 bTripBeforeThisOne.tripnr        = aa-tp_trip.tripnr - 1 NO-LOCK NO-ERROR.

                      IF NOT AVAIL bTripBeforeThisOne
                      THEN
                        FIND FIRST bTripBeforeThisOne WHERE
                                   bTripBeforeThisOne.companycode   = aa-tp_trip.companycode   AND
                                   bTripBeforeThisOne.tp_file_seqnr = aa-tp_trip.tp_file_seqnr AND
                                   bTripBeforeThisOne.tripnr        < aa-tp_trip.tripnr        NO-LOCK NO-ERROR.

                      IF AVAIL bTripBeforeThisOne
                      THEN
                        aa-tp_trip.dt_requested = bTripBeforeThisOne.dt_requested.
                  END.

                END.

              END.

            END.


            IF (aa-tp_trip.qualifier = "COLLECTION" OR aa-tp_trip.qualifier = "TRANSFER") AND aa-tp_trip.endpoint_type = "VOYAGE"
            THEN DO:

              IF NOT AVAILABLE b-ca-u_shipment_item OR b-ca-u_shipment_item.full_in_terminalcode = ""
              THEN
                ASSIGN
                  aa-tp_trip.endpoint_location = b-ca-u_shipment.locationcode
                  aa-tp_trip.dt_closing        = dClosing
                  aa-tp_trip.tm_closing        = cTIM_closing.
              ELSE DO:
                ASSIGN
                  aa-tp_trip.endpoint_location = b-ca-u_shipment_item.full_in_terminalcode
                  aa-tp_trip.dt_closing        = b-ca-u_shipment_item.dt_closing
                  aa-tp_trip.tm_closing        = b-ca-u_shipment_item.tim_closing.
              END.

            END.

        END. /* transaction */

      END. /* each aa-tp_trip .. */

      ON WRITE OF aa-tp_trip REVERT.

    END. /* b-aa-tp_file */

  END. /* b-ca-u_shipment */

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-caSync-u-voyage-container) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE caSync-u-voyage-container Procedure
PROCEDURE caSync-u-voyage-container :
/*------------------------------------------------------------------------------
  Purpose:
  Parameters:  <none>
  Notes:
------------------------------------------------------------------------------*/

  DEF INPUT PARAMETER piVesselnr                AS INTEGER   NO-UNDO.
  DEF INPUT PARAMETER pcContainerPrefix         AS CHARACTER NO-UNDO.
  DEF INPUT PARAMETER pcContainerNr             AS CHARACTER NO-UNDO.

  DEF BUFFER b-ca-u_shipment                 FOR ca-u_shipment.
  DEF BUFFER b-ca-u_shipment_item            FOR ca-u_shipment_item.
  DEF BUFFER b-ca-u_shipment_item_container  FOR ca-u_shipment_item_container.
  DEF BUFFER b-ca-u_voyage_container         FOR ca-u_voyage_container.
  DEF BUFFER b-aa-tp_file                    FOR aa-tp_file.
  DEF BUFFER b-update_file                   FOR aa-tp_file.

  IF piVesselnr = 0 THEN RETURN.

  FOR EACH b-ca-u_voyage_container WHERE
           b-ca-u_voyage_container.companycode     = sp-companycode    AND
           b-ca-u_voyage_container.vesselnr        = piVesselnr        AND
           b-ca-u_voyage_container.inward-outward  = "O"               AND
           b-ca-u_voyage_container.containerprefix = pcContainerPrefix AND
           b-ca-u_voyage_container.containernr     = pcContainerNr     NO-LOCK,
      EACH b-ca-u_shipment_item_container WHERE
           b-ca-u_shipment_item_container.companycode     = sp-companycode AND
           b-ca-u_shipment_item_container.vesselnr        = b-ca-u_voyage_container.vesselnr AND
           b-ca-u_shipment_item_container.containerprefix = b-ca-u_voyage_container.containerprefix AND
           b-ca-u_shipment_item_container.containernr     = b-ca-u_voyage_container.containernr NO-LOCK,
      EACH b-aa-tp_file WHERE
           b-aa-tp_file.companycode     = sp-companycode AND
           b-aa-tp_file.shipment_seqnr  = b-ca-u_shipment_item_container.shipment_seqnr AND
           b-aa-tp_file.item_seqnr      = b-ca-u_shipment_item_container.item_seqnr AND
           b-aa-tp_file.containerprefix = b-ca-u_shipment_item_container.containerprefix AND
           b-aa-tp_file.containernr     = b-ca-u_shipment_item_container.containernr NO-LOCK:

      DO TRANSACTION:

        FIND FIRST b-update_file WHERE ROWID( b-update_file) = ROWID(b-aa-tp_file) EXCLUSIVE-LOCK NO-WAIT NO-ERROR.
        IF AVAIL b-update_file
        THEN
          ASSIGN
            b-update_file.containertype    = b-ca-u_voyage_container.typecode
            b-update_file.reefer_temp1     = b-ca-u_voyage_container.reefer_temp1
            b-update_file.reefer_temp2     = b-ca-u_voyage_container.reefer_temp2
            b-update_file.sealno           = b-ca-u_voyage_container.sealno
            b-update_file.release_pincode  = b-ca-u_voyage_container.release_pincode
            b-update_file.overlength_back  = b-ca-u_voyage_container.overlength_back
            b-update_file.overwidth_right  = b-ca-u_voyage_container.overwidth_right
            b-update_file.overwidth_left   = b-ca-u_voyage_container.overwidth_left
            b-update_file.overlength_front = b-ca-u_voyage_container.overlength_front
            b-update_file.overheight       = b-ca-u_voyage_container.overheight
            .

      END.



  END. /* b-ca-u_shipment */

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-caSync-u-voyage-shipment) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE caSync-u-voyage-shipment Procedure
PROCEDURE caSync-u-voyage-shipment :
/*------------------------------------------------------------------------------
  Purpose:
  Parameters:  <none>
  Notes:
------------------------------------------------------------------------------*/
  DEF INPUT PARAMETER piShipmentSeqnr AS INTEGER NO-UNDO.
  DEF INPUT PARAMETER piItemSeqnr     AS INTEGER NO-UNDO.
  DEF INPUT PARAMETER piTpFileSeqnr   AS INTEGER NO-UNDO.
  DEF INPUT PARAMETER pcQualifier     AS CHARACTER NO-UNDO.

  DEF BUFFER b-ca-u_shipment       FOR ca-u_shipment.
  DEF BUFFER b-ca-u_shipment_item  FOR ca-u_shipment_item.
  DEF BUFFER b-aa-tp_file          FOR aa-tp_file.
  DEF BUFFER b-aa-tp_trip          FOR aa-tp_trip.
  DEF BUFFER bTripBeforeThisOne    FOR aa-tp_trip.
  DEF BUFFER b-update-file FOR aa-tp_file.


  DEF VAR cTIM_ETS       AS CHARACTER NO-UNDO.
  DEF VAR cTIM_ETA       AS CHARACTER NO-UNDO.
  DEF VAR dETS           AS DATE      NO-UNDO.
  DEF VAR dETA           AS DATE      NO-UNDO.
  DEF VAR cDes           AS CHARACTER NO-UNDO.
  DEF VAR dClosing       AS DATE      NO-UNDO.
  DEF VAR cTIM_closing   AS CHARACTER NO-UNDO.
  DEF VAR dAvailable     AS DATE      NO-UNDO.
  DEF VAR cTIM_available AS CHARACTER NO-UNDO.

  DEF VAR ii AS INT NO-UNDO.

  IF piShipmentSeqnr = 0 THEN RETURN.


  DEF VAR iPrgIdx AS INT NO-UNDO.
  DO iPrgIdx = 1 TO 6 WHILE PROGRAM-NAME(iPrgIdx) <> ?:
    spLogThis ("call stack(" + string(iPrgIdx) + "): " + PROGRAM-NAME(iPrgIdx), NO,NO,YES).
    IF INDEX(PROGRAM-NAME(iPrgIdx),"dbtrigger") > 0 THEN LEAVE.
  END.

  II = ETIME.

  FOR EACH b-ca-u_shipment WHERE
           b-ca-u_shipment.companycode = sp-companycode AND
           b-ca-u_shipment.shipment_seqnr = piShipmentSeqnr NO-LOCK:

    FOR EACH b-aa-tp_file WHERE
             b-aa-tp_file.companycode    = sp-companycode AND
             b-aa-tp_file.tp_file_seqnr  = piTpFileSeqnr /* AND
             b-aa-tp_file.shipment_seqnr = b-ca-u_shipment.shipment_seqnr */ NO-LOCK :

      IF piItemSeqnr <> 0 AND b-aa-tp_file.item_seqnr <> piItemSeqnr
      THEN NEXT.

      ASSIGN
         cTIM_ETS       = ""
         cTIM_ETA       = ""
         cTIM_closing   = ""
         cTIM_available = ""
         dAvailable     = ?
         dClosing       = ?
         dETS           = ?
         dETA           = ?
         cDes           = "".

      FIND FIRST aa-vessel OF b-ca-u_shipment NO-LOCK NO-ERROR.
      cDes = aa-vessel.des.

      IF b-ca-u_shipment.locationcode <> ""
      THEN DO:
        FIND FIRST ca-u_vessel_pol_terminal WHERE
                   ca-u_vessel_pol_terminal.companycode  = b-ca-u_shipment.companycode AND
                   ca-u_vessel_pol_terminal.vesselnr     = b-ca-u_shipment.vesselnr AND
                   ca-u_vessel_pol_terminal.pol_portcode = b-ca-u_shipment.pol_portcode AND
                   ca-u_vessel_pol_terminal.locationcode = b-ca-u_shipment.locationcode NO-LOCK NO-ERROR.
        IF NOT AVAILABLE ca-u_vessel_pol_terminal
        THEN.
        /*
          MESSAGE "Could not find POL-terminal (" b-ca-u_shipment.vesselnr b-ca-u_shipment.pol_portcode b-ca-u_shipment.locationcode ") in voyage" VIEW-AS ALERT-BOX TITLE "Sync transportportplanning".
         */
        ELSE
          ASSIGN
            cTIM_ETS          = ca-u_vessel_pol_terminal.time_ets
            dETS              = ca-u_vessel_pol_terminal.dt_ets
            cTIM_closing      = ca-u_vessel_pol_terminal.tim_closing
            dClosing          = ca-u_vessel_pol_terminal.dt_closing.
      END.

      IF b-ca-u_shipment.pod_locationcode <> ""
      THEN DO:
        FIND FIRST ca-u_vessel_pod_terminal WHERE
                   ca-u_vessel_pod_terminal.companycode  = b-ca-u_shipment.companycode AND
                   ca-u_vessel_pod_terminal.vesselnr     = b-ca-u_shipment.vesselnr AND
                   ca-u_vessel_pod_terminal.pod_portcode = b-ca-u_shipment.pod_portcode AND
                   ca-u_vessel_pod_terminal.locationcode = b-ca-u_shipment.pod_locationcode NO-LOCK NO-ERROR.
        IF NOT AVAILABLE ca-u_vessel_pod_terminal
        THEN.
        /*
          MESSAGE "Could not find POD-terminal (" b-ca-u_shipment.vesselnr b-ca-u_shipment.pod_portcode b-ca-u_shipment.pod_locationcode ") in voyage" VIEW-AS ALERT-BOX TITLE "Sync transportportplanning".
         */
        ELSE
          ASSIGN
            cTIM_ETA       = ca-u_vessel_pod_terminal.time_eta
            dETA           = ca-u_vessel_pod_terminal.dt_eta
            cTIM_available = ca-u_vessel_pod_terminal.time_available
            dAvailable     = ca-u_vessel_pod_terminal.dt_available.
      END.

      /* ----------------------- */

      DO TRANSACTION:

          FIND FIRST b-update-file WHERE ROWID(b-update-file) = ROWID(b-aa-tp_file) EXCLUSIVE-LOCK NO-WAIT NO-ERROR.
          IF AVAIL b-update-file
          THEN DO:

            ASSIGN
              b-update-file.voyage_tim_ets  = cTIM_ETS
              b-update-file.voyage_tim_eta  = cTIM_ETA
              b-update-file.voyage_dt_ets   = dETS
              b-update-file.voyage_dt_eta   = dETA
              b-update-file.voyage_des      = cDes.

          END.
          ELSE DO:

          END.

      END.

      /* trigger uit; die komt nog voorbij vanuit catchchange vanuit aa-tp_file trigger */
      ON WRITE OF aa-tp_trip OVERRIDE DO: END.

      FOR EACH b-aa-tp_trip WHERE
               b-aa-tp_trip.companycode   = b-aa-tp_file.companycode AND
               b-aa-tp_trip.tp_file_seqnr = b-aa-tp_file.tp_file_seqnr AND
               b-aa-tp_trip.qualifier     = pcQualifier NO-LOCK:

        DO TRANSACTION:

            FIND FIRST aa-tp_trip WHERE ROWID(aa-tp_trip) = ROWID(b-aa-tp_trip) EXCLUSIVE-LOCK NO-WAIT NO-ERROR.
            IF NOT AVAIL aa-tp_trip OR LOCKED aa-tp_trip
            THEN NEXT.

            FIND FIRST b-ca-u_shipment_item WHERE
                       b-ca-u_shipment_item.companycode    = b-aa-tp_file.companycode AND
                       b-ca-u_shipment_item.shipment_seqnr = b-aa-tp_file.shipment_seqnr AND
                       b-ca-u_shipment_item.item_seqnr     = b-aa-tp_file.item_seqnr NO-LOCK NO-ERROR.


            IF /* aa-tp_trip.qualifier = "DELIVERY" AND */ aa-tp_trip.startpoint_type = "VOYAGE"
            THEN
              ASSIGN
                aa-tp_trip.startpoint_location = b-ca-u_shipment.pod_locationcode
                aa-tp_trip.dt_available        = dAvailable
                aa-tp_trip.tim_available       = cTIM_available.

            /* ---------------------------------------------------------------------------------- */
            /* Endpoint */
            /* ---------------------------------------------------------------------------------- */

            IF aa-tp_trip.endpoint_type = "VOYAGE"
            THEN DO:

              IF b-ca-u_shipment_item.full_in_terminalcode = ""
              THEN
                ASSIGN
                  aa-tp_trip.endpoint_location = b-ca-u_shipment.locationcode
                  aa-tp_trip.dt_closing        = dClosing
                  aa-tp_trip.tm_closing        = cTIM_closing.
              ELSE
                ASSIGN
                  aa-tp_trip.endpoint_location = b-ca-u_shipment_item.full_in_terminalcode
                  aa-tp_trip.dt_closing        = b-ca-u_shipment_item.dt_closing
                  aa-tp_trip.tm_closing        = b-ca-u_shipment_item.tim_closing.

            END.

            /* ---------------------------------------------------------------------------------- */
            /* Fill requested date for TRANSFER */
            /* ---------------------------------------------------------------------------------- */
            IF aa-tp_trip.dt_requested = ? AND aa-tp_trip.qualifier = "TRANSFER"
            THEN DO:

              /* Even de 1e move pakken om te zien of we in een delivery zitten of collection */
              FIND FIRST aa-tp_move WHERE
                         aa-tp_move.companycode = aa-tp_trip.companycode AND
                         aa-tp_move.tp_trip_seqnr = aa-tp_trip.tp_trip_seqnr NO-LOCK NO-ERROR.
              IF AVAILABLE aa-tp_move
              THEN DO:

                IF aa-tp_trip.startpoint_type = "VOYAGE"
                THEN DO:
                  /* Rail/Barge: when starting from voyage; and delivery; fill requested date with date available */
                  aa-tp_trip.dt_requested = (IF dAvailable <> ? THEN dAvailable ELSE dETA).
                END.
                ELSE
                  IF aa-tp_move.delivery_collection = "C"
                  THEN DO:

                    /* Rail/Barge: when part of collection; difficult to determine date.. so take date from previous trip */
                    IF aa-tp_trip.qualifier = "TRANSFER"
                    THEN DO:
                      FIND FIRST bTripBeforeThisOne WHERE
                                 bTripBeforeThisOne.companycode = aa-tp_trip.companycode AND
                                 bTripBeforeThisOne.tp_file_seqnr = aa-tp_trip.tp_file_seqnr AND
                                 bTripBeforeThisOne.tripnr        = aa-tp_trip.tripnr - 1 NO-LOCK NO-ERROR.

                      IF NOT AVAIL bTripBeforeThisOne
                      THEN
                        FIND FIRST bTripBeforeThisOne WHERE
                                   bTripBeforeThisOne.companycode   = aa-tp_trip.companycode   AND
                                   bTripBeforeThisOne.tp_file_seqnr = aa-tp_trip.tp_file_seqnr AND
                                   bTripBeforeThisOne.tripnr        < aa-tp_trip.tripnr        NO-LOCK NO-ERROR.

                      IF AVAIL bTripBeforeThisOne
                      THEN
                        aa-tp_trip.dt_requested = bTripBeforeThisOne.dt_requested.
                  END.

                END.

              END.

            END.

        END. /* transaction */

      END. /* each aa-tp_trip .. */

      ON WRITE OF aa-tp_trip REVERT.

    END. /* b-aa-tp_file */

  END. /* b-ca-u_shipment */

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-DebugInfo) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE DebugInfo Procedure
PROCEDURE DebugInfo :
/*------------------------------------------------------------------------------
  Purpose:
  Parameters:  <none>
  Notes:
------------------------------------------------------------------------------*/
  DEFINE INPUT PARAMETER pcCompany AS CHAR.
  DEFINE INPUT PARAMETER piShipment AS INT .
  DEFINE INPUT PARAMETER piItemNr  AS INT.
  DEFINE INPUT PARAMETER pcPrefix AS CHAR.
  DEFINE INPUT PARAMETER pcNr AS CHAR.

  DEF VAR xx AS CHAR NO-UNDO.

  FOR EACH aa-tp_file WHERE
           aa-tp_file.companycode = pcCompany AND
           aa-tp_file.shipment_seqnr = piShipment AND
           aa-tp_file.item_seqnr = piItemNr:

     xx = xx + "aa-tp_file: " + STRING(tp_file_seqnr) + "<" + aa-tp_file.containerprefix + "><" + aa-tp_file.containernr + ">" + CHR(10).

  END.

  xx = "Search for item: " + STRING(piItemNr) + "<" + pcPrefix  + "><" + pcNr  + ">" + CHR(10) + CHR(10) + xx.

  MESSAGE xx VIEW-AS ALERT-BOX.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-GetMultiParameter) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE GetMultiParameter Procedure
PROCEDURE GetMultiParameter :
/*------------------------------------------------------------------------------
  Purpose:
  Parameters:  <none>
  Notes:
------------------------------------------------------------------------------*/
  DEFINE INPUT        PARAMETER piShipment_seqnr   AS INT NO-UNDO.
  DEFINE INPUT        PARAMETER piItem_seqnr       AS INT NO-UNDO.
  DEFINE OUTPUT       PARAMETER piMulti_item_seqnr AS INT NO-UNDO.
  DEFINE OUTPUT       PARAMETER plMulti            AS LOG NO-UNDO.

  DEFINE BUFFER bDezeShipment FOR ca-u_shipment.
  DEFINE BUFFER bMultiItem    FOR ca-u_shipment_item.

  piMulti_item_seqnr = piItem_seqnr.

  FIND FIRST bDezeShipment WHERE
             bDezeShipment.companycode    = sp-companycode   AND
             bDezeShipment.shipment_seqnr = piShipment_seqnr NO-LOCK NO-ERROR.
  IF NOT AVAIL bDezeShipment THEN RETURN.

  plMulti = (bDezeShipment.ind_multi_receipt OR bDezeShipment.ind_multi_delivery).

  IF plMulti
  THEN DO:

    /* find the very first item of this shipment */
    FIND FIRST bMultiItem  WHERE
               bMultiItem.companycode = sp-companycode AND
               bMultiItem.shipment_seqnr = piShipment_seqnr USE-INDEX ca-u_shipment_item NO-LOCK NO-ERROR.
    IF NOT AVAIL bMultiItem
    THEN DO:
      ShowMessage("GetMultiParameter","Shipment: " + bDezeShipment.bookingnr,"Sync to TP not possible; missing shipment item ","",NO).
      RETURN.
    END.

    piMulti_item_seqnr = bMultiItem.item_seqnr.

  END.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-spMailWithBlat) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE spMailWithBlat Procedure
PROCEDURE spMailWithBlat :
/*------------------------------------------------------------------------------
  Purpose:
  Parameters:  <none>
  Notes:
------------------------------------------------------------------------------*/
{system/include/sp-spMailWithBlat.i}
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

/* ************************  Function Implementations ***************** */

&IF DEFINED(EXCLUDE-ShowMessage) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION ShowMessage Procedure
FUNCTION ShowMessage RETURNS LOGICAL
  ( pcProcName AS CHAR,
    pcKeys AS CHAR,
    pcMessage AS CHAR,
    pcMessageType AS CHARACTER,
    plBlatOnly AS LOGICAL ) :
/*------------------------------------------------------------------------------
  Purpose:
    Notes:
------------------------------------------------------------------------------*/

  DEF VAR lOk AS LOGICAL NO-UNDO.
  DEF VAR cSubject AS CHAR NO-UNDO.
  DEF VAR cBody AS CHAR NO-UNDO.

  IF glSchedulerActive OR plBlatOnly
  THEN DO:

    cSubject = "ca-sync-tp issue in " + pcProcName.

    cBody = pcKeys + CHR(10) + CHR(10) + pcMessage.

    RUN spMailWithBlat (INPUT  ""                                                                 /* pcBodyFileName */
                       ,INPUT  cBody                                                              /* plcBodyText */
                       ,''                                                                        /* pcAttachmentFileName */
                       ,'ca-sync-tp@eucon.com'                                                    /* pcSender */
                       ,INPUT  "mclinton@eucon.nl,rcolle@eucon.nl"                                /* pcRecipients */
                       ,INPUT  "peter.baaijens@softpak.nl"                                        /* cc */
                       ,INPUT  ""                                                                 /* bcc */
                       ,INPUT  cSubject                                                           /* pcSubject */
                       ,INPUT 'UTF8=YES' /* = ook default */                                      /* pcOptions */
                       ,''                                                                        /* pcRawBlatOptions */
                       ,OUTPUT lOk ).

  END.
  ELSE DO:

    CASE pcMessageType:
        WHEN "ERROR"   THEN MESSAGE pcMessage VIEW-AS ALERT-BOX ERROR.
        WHEN "WARNING" THEN MESSAGE pcMessage VIEW-AS ALERT-BOX WARNING.
        WHEN "INFO"    THEN MESSAGE pcMessage VIEW-AS ALERT-BOX INFO.
        OTHERWISE           MESSAGE pcMessage VIEW-AS ALERT-BOX ERROR.
    END CASE.

  END.

  RETURN FALSE.   /* Function return value. */

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-spCloseLogfile) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION spCloseLogfile Procedure
FUNCTION spCloseLogfile RETURNS CHARACTER
  ( ) :

  OUTPUT STREAM logfile CLOSE.

  RETURN "".   /* Function return value. */

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-spGetEntry) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION spGetEntry Procedure
FUNCTION spGetEntry RETURNS CHARACTER
   ( pcLabel      AS CHAR,
    pcValueList  AS CHAR,
    pcSep1       AS CHAR,
    pcSep2       AS CHAR ) :

 {system/include/sp-get-entry.i}

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-spLogThis) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION spLogThis Procedure
FUNCTION spLogThis RETURNS LOGICAL
  ( INPUT pText         AS CHAR,
    INPUT pTimeStamp    AS LOGICAL,
    INPUT pSkipBefore   AS LOGICAL,
    INPUT pSkipAfter    AS LOGICAL ) :

  IF glUseLogging = NO THEN RETURN NO.

  spOpenLogfile().

  IF pText = "line" THEN pText = FILL("-",80).

  IF pSkipBefore
  THEN
    PUT STREAM logfile SKIP.

  PUT STREAM logfile UNFORMATTED (IF pTimeStamp THEN STRING(NOW) + CHR(9) ELSE "") pText.

  IF pSkipAfter
  THEN
    PUT STREAM logfile SKIP.

  spCloseLogfile().

  RETURN YES.

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-spOpenLogfile) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION spOpenLogfile Procedure
FUNCTION spOpenLogfile RETURNS CHARACTER
  ( /* parameter-definitions */ ) :

  DEFINE VARIABLE cLogfile AS CHARACTER NO-UNDO.

  cLogfile = SESSION:TEMP-DIRECTORY + STRING(TODAY,'99-99-9999') + "caSyncTransport.log".

  IF SEARCH(cLogfile) = ?
  THEN OUTPUT STREAM logfile TO VALUE(cLogfile) UNBUFFERED.
  ELSE OUTPUT STREAM logfile TO VALUE(cLogfile) UNBUFFERED APPEND.


END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-TransportfileHasBeenUsed) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION TransportfileHasBeenUsed Procedure
FUNCTION TransportfileHasBeenUsed RETURNS LOGICAL
  ( pRowid AS ROWID ) :
/*------------------------------------------------------------------------------
  Purpose:
    Notes:
------------------------------------------------------------------------------*/

  RETURN CAN-FIND (FIRST ttTPfile WHERE ttTPfile.thisrowid = pRowid NO-LOCK).

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-TransportFileMarkAsUsed) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION TransportFileMarkAsUsed Procedure
FUNCTION TransportFileMarkAsUsed RETURNS LOGICAL
  ( prowid AS ROWID ) :
/*------------------------------------------------------------------------------
  Purpose:
    Notes:
------------------------------------------------------------------------------*/

  CREATE ttTPfile.
  ttTPfile.thisrowid = pRowid.

  RETURN YES.

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

